package algae.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Hashtable;
import javax.swing.BorderFactory;
import javax.swing.border.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import algae.simulation.*;

import algae.simulation.view.*;
import algae.simulation.view.ViewAgent;
import algae.simulation.Settings;
import algae.gui.ContinueDlg;
import algae.gui.ANNWindow;
import netView.NetViewSource;
 // changed by cb

public class MainGUI extends JFrame implements ActionListener
{
	GUIWC contr;

	HelpWin hWin=null;
	ANNWindow annWin=null;    	
	    	
        WorldState ws;
	
	InfoWin iWin=null;
	
	JMenuBar grayMenuBar;
	JToolBar toolBar;
	JPanel toolPanel;
       	ImagePanel aqua;
       	JScrollPane scrollPane ;
	JPanel statusPanel;

	JPanel SteppingPanel;
	JButton SteppingButton = new JButton("Set stepping");
	JTextField SteppingTF = new JTextField(5);

        int stepping =1; 
        int stepCount =stepping-1; 

	boolean alreadyDrawing=false;
	
	JLabel stateLabel=new JLabel(); // running/...
	JLabel lightLabel=new JLabel(); // light intensity
	JLabel substLabel=new JLabel(); // substrate amount
	JLabel algaeLabel=new JLabel(); // # of algaes
	JLabel stepLabel=new JLabel();  // progress of simulation
	JProgressBar progress; // progress bar for simulation		
	
	public JLabel mousePosLabel = new JLabel("Pos: --/--");
	public JLabel mouseLightLabel = new JLabel("Light: ----");
	public JLabel mouseSubstrateLabel = new JLabel("Substrate: ----");
	public JLabel mousePheromoneLabel = new JLabel("Pheromone: ----");
	public JLabel mouseAgentLabel = new JLabel("Agent: ----");
        public JLabel mouseSelectionLabel = new JLabel("Selection: ----");
		
	GridBagLayout gridbag = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();
 
	JComboBox AlgList = new JComboBox();
        
        Timer timer;

	boolean Drawing = false;

	public int selection=-1; // no algae selected yet
	boolean simuPaused=false;
	boolean simuStopped=true;

	boolean dispAlgaes=true;
	boolean dispPhero=true;
	boolean dispSubstrate=true;
	boolean dispLight=true;

	float aquaScale = 6.0f;
	
	Settings config;
			
	int SimulationDelay=50;
        boolean Running = false; 
                          	
        ImageIcon OpenRolloverImg=new ImageIcon("images/OpenImgOver.gif");
        ImageIcon SaveRolloverImg=new ImageIcon("images/SaveImgOver.gif");
        ImageIcon OpenImg=new ImageIcon("images/OpenImg.gif");
        ImageIcon SaveImg=new ImageIcon("images/SaveImg.gif");
	ImageIcon ANNImg=new ImageIcon("images/ANN.gif");

        JSlider SpeedSlider;
        JSlider LightSlider;
 
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        Image AlgUp=toolkit.getImage("images/al_up.gif");
        Image AlgDown=toolkit.getImage("images/al_down.gif");
        Image AlgLeft=toolkit.getImage("images/al_left.gif");
        Image AlgRight=toolkit.getImage("images/al_right.gif");

        Container contentPane = getContentPane();
       
        JMenu FileMenu = new JMenu("File");
       
        JMenuItem LoadConfigMenuItem = new JMenuItem("Load config",KeyEvent.VK_L);
        JMenuItem SaveConfigAsMenuItem = new JMenuItem("Save config as...",KeyEvent.VK_A);
        JMenuItem LoadStateMenuItem = new JMenuItem("Load state",KeyEvent.VK_T);
        JMenuItem SaveStateAsMenuItem = new JMenuItem("Save state as...",KeyEvent.VK_S);
        JMenuItem SaveStateMenuItem = new JMenuItem("Save state",KeyEvent.VK_V);
        JMenuItem ResetMenuItem = new JMenuItem("Reset",KeyEvent.VK_R);
        JMenuItem QuitMenuItem=new JMenuItem("Quit Simulation",KeyEvent.VK_Q);
        
     	JMenu WindowMenu=new JMenu("Windows");
     	JMenuItem ANNWindowItem = new JMenuItem("ANN Window",KeyEvent.VK_A); 
       	JMenuItem InfoItem = new JMenuItem("Info window", KeyEvent.VK_I);
        JMenu HelpMenu=new JMenu("Help");
       	JMenuItem HelpTopicsMenuItem = new JMenuItem("Topics", KeyEvent.VK_T);
        JMenuItem HelpAboutMenuItem=new JMenuItem("About ALGAE", KeyEvent.VK_A);
	
        JButton NewButton=new JButton(new ImageIcon("images/NewImg.gif"));
        JButton OpenButton=new JButton(OpenImg);                
        JButton SaveButton=new JButton(SaveImg);
        JButton PlayButton=new JButton(new ImageIcon("images/PlayImg.gif"));
	JButton PauseButton=new JButton(new ImageIcon("images/PauseImg.gif"));
        JButton StepButton=new JButton(new ImageIcon("images/StepImg.gif"));
        JButton ResetButton=new JButton(new ImageIcon("images/ResetImg.gif"));
        JButton HelpButton=new JButton(new ImageIcon("images/HelpImg.gif"));
  	JButton ZoomInButton=new JButton(new ImageIcon("images/ZoomIn.gif"));
  	JButton ZoomOutButton=new JButton(new ImageIcon("images/ZoomOut.gif"));
	JButton ANNButton=new JButton(ANNImg);                
        
	JCheckBox NoDisplayCB=new JCheckBox("Display ON/OFF");
  	JCheckBox DayNightCB=new JCheckBox("Day/Night cycle");
        JCheckBox DummyCB = new JCheckBox("Dummy");

	JCheckBox DrawAlgaeCB = new JCheckBox("Draw algaes");
	JCheckBox DrawPheroCB = new JCheckBox("Draw pheromone");
	JCheckBox DrawSubstCB = new JCheckBox("Draw substrate");
      	JCheckBox DrawLightCB = new JCheckBox("Draw light");
      
        JCheckBox DrawGridCB = new JCheckBox("Draw Grid");
        boolean drawGrid = true;

  	public void AddMenuItems()
        {
        	// add Simulation menu
		FileMenu.setMnemonic(KeyEvent.VK_F);
          	grayMenuBar.add(FileMenu);
          	
          	// items of the Simulation menu
          	FileMenu.add(LoadConfigMenuItem);
		//FileMenu.add(SaveConfigAsMenuItem);
		//FileMenu.add(LoadStateMenuItem);
		//FileMenu.add(SaveStateAsMenuItem);
		FileMenu.add(SaveStateMenuItem);
		FileMenu.addSeparator();
		FileMenu.add(ResetMenuItem);
		FileMenu.addSeparator();
          	FileMenu.add(QuitMenuItem);         
		QuitMenuItem.addActionListener(this);
		
		// add windows menu
		WindowMenu.setMnemonic(KeyEvent.VK_W);
		grayMenuBar.add(WindowMenu);
		
		// add items for windows menu
		WindowMenu.addSeparator();
		ANNWindowItem.addActionListener(this);
          	WindowMenu.add(ANNWindowItem);         
		InfoItem.addActionListener(this);
          	WindowMenu.add(InfoItem);         
		
		// add Help menu
		HelpMenu.setMnemonic(KeyEvent.VK_H);
		grayMenuBar.add(HelpMenu);
			
		// items of the Help menu
		HelpTopicsMenuItem.addActionListener(this);
          	HelpMenu.add(HelpTopicsMenuItem); 
          	HelpMenu.addSeparator();
          	HelpAboutMenuItem.addActionListener(this);
		HelpMenu.add(HelpAboutMenuItem);          	                  
        }	

        public void actionPerformed(ActionEvent e)
        {
	    Object src=e.getSource();
	    if (src==QuitMenuItem)
		{
		    //Custom button text
		    Object[] options = {"Yes","No",};
                    int result = JOptionPane.showOptionDialog(this,
                        "Do you really like to quit this simulation ?",
                        "Confirmation",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,
                        options,
                        options[1]);
		    if (result==JOptionPane.YES_OPTION)
		    {
		    	if (iWin!=null)
		    	   iWin.dispose();
		        dispose();
			//System.exit(0);		
		    }
		}
	    if (src==HelpTopicsMenuItem)
	    {
	    	if (hWin==null)
	    	    hWin=new HelpWin("help\\index.htm");
	    	hWin.setTitle("ALGAE Online help");
	    	hWin.setResizable(true);
		hWin.setSize(500,600);
		hWin.setVisible(true);
		//hWin.pack();
		
	    }
	    if (src==ResetButton)
	    {
		//Custom button text
		Object[] options = {"Yes","No",};
                int result = JOptionPane.showOptionDialog(this,
                        "Do you really like to reset this simulation ?",
                        "Confirmation",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,
                        options,
                        options[1]);
		if (result==JOptionPane.YES_OPTION)
		{
		    contr = new GUIWC(config,this);
		    selection=-1;		    
		    WorldState wsLocal=contr.getState();
	    	    paintAll(wsLocal,false);
	    	}	    	
	    }
	    if ((src==PlayButton) && (!Running))
	    {
	    	System.out.println("Play button pressed...");
	    	Running=true;
	    	
	    	simuPaused=false;
	    	simuStopped=false;
	    	
		SteppingButton.setEnabled(false);
		SteppingTF.setEnabled(false);
		ResetButton.setEnabled(false);
		StepButton.setEnabled(false);
	    	PauseButton.setEnabled(true);
	    	PlayButton.setEnabled(false);
	    	AlgList.setEnabled(false);
	        ANNButton.setEnabled(false);
		
	    	timer.start();
	    	setState("running...");
	    }
	    if ((src==PauseButton) && (Running))
	    {
		reBuildComboItems();
		
		System.out.println("Pause button pressed...");
	    	Running=false;
	    	
	    	simuPaused=true;
	    	simuStopped=false;

		SteppingButton.setEnabled(true);
		SteppingTF.setEnabled(true);
	    	ResetButton.setEnabled(true);
	    	StepButton.setEnabled(true);
	    	PauseButton.setEnabled(false);
	    	PlayButton.setEnabled(true);
	    	AlgList.setEnabled(true);
		ANNButton.setEnabled(true);
		
	    	timer.stop();	    	
	    	setState("stopped...");
	    }
	    if ((src==StepButton) && (!Running))
	    {
		System.out.println("Step-Button button pressed...");
		WorldState wsLocal=contr.run();
		System.out.println("STEPBUTTON: WorldState captured...");

		if (wsLocal==null)
		{
		    System.out.println("STEPBUTTON: WorldState==null...");
    		    Running=false;
	    	
		    simuPaused=true;
		    simuStopped=false;

		    SteppingButton.setEnabled(true);
		    SteppingTF.setEnabled(true);
		    ResetButton.setEnabled(true);
		    StepButton.setEnabled(true);
		    PauseButton.setEnabled(false);
		    PlayButton.setEnabled(true);
		    AlgList.setEnabled(true);
		    ANNButton.setEnabled(true);
				    		
		    setState("stopped...");
		}
	        else
		{
		    System.out.println("STEPBUTTON: WorldState!=null -> paintAll(...)...");
		    paintAll(wsLocal,false);
		}

		setState("single step done...");
		reBuildComboItems();
	    	
	    }
	    if (src==ZoomInButton)
	    {
	    	if (aquaScale<10.0f)
	    	    aquaScale+=1.0f;
	    	if (aquaScale==10.0f)
	    	   ZoomInButton.setEnabled(false);
	    	ZoomOutButton.setEnabled(true);	
	    	aqua.setScale(aquaScale);
	    	setNewAreaDimensions();
	    }
	    if (src==ZoomOutButton)
	    {
	    	if (aquaScale>1.0f)
	    	    aquaScale-=1.0f;
	    	if (aquaScale==1.0f)
	           ZoomOutButton.setEnabled(false);
	        ZoomInButton.setEnabled(true);
	    	aqua.setScale(aquaScale);
	    	setNewAreaDimensions();
	    }
	    if ((src==AlgList)&&(!Running)&&(!Drawing))
	    {
	    	if (AlgList.getSelectedItem()==null)
	    	{
	    	   selection=-1;
	    	   return;
	    	}
	    	String tmp=(String)AlgList.getSelectedItem();
	    	
	    	selection=java.lang.Integer.parseInt(tmp);
	    	
	    	//change: peisen
	    	//System.out.println("ALGLIST: parse getSelectedItem() - selection (all) = "+selection);

                if (selection!=-1)
	           mouseSelectionLabel.setText("Selection: "+Integer.toString(selection));
	        else
	           mouseSelectionLabel.setText("Selection: ----");
	    	
	    	WorldState wsLocal=contr.getState();
	    	paintAll(wsLocal,false);
	    }
	    if (src==DrawGridCB)
	    {
		drawGrid=DrawGridCB.isSelected();
		aqua.turnOnOffGrid(drawGrid);
	    }
	    if (src==DrawAlgaeCB)
	    {
	    	System.out.println("DrawAlgaeCB changed");
	    	dispAlgaes=DrawAlgaeCB.isSelected();
	    	
	    	WorldState wsLocal=contr.getState();
	    	paintAll(wsLocal,false);
	    }
	    if (src==DrawPheroCB)
	    {
	    	System.out.println("DrawPheroCB changed");
	    	dispPhero=DrawPheroCB.isSelected();
	    	
	    	WorldState wsLocal=contr.getState();
	    	paintAll(wsLocal,false);
	    }
	    if (src==DrawSubstCB)
	    {
	    	System.out.println("DrawSubstCB changed");
	    	dispSubstrate=DrawSubstCB.isSelected();
	    	
	    	WorldState wsLocal=contr.getState();
	    	paintAll(wsLocal,false);
	    }
	    if (src==DrawLightCB)
	    {
	    	System.out.println("DrawLightCB changed");
	    	dispLight=DrawLightCB.isSelected();
	    	
	    	WorldState wsLocal=contr.getState();
	    	paintAll(wsLocal,false);	    	
	    }
	    
	    if (src==InfoItem)
	    {
	    	if (iWin==null)
	    	    iWin=new InfoWin();
	    	iWin.setResizable(true);
		iWin.setSize(800,200);
		iWin.setVisible(true);
		iWin.pack();
		
		if (selection!=-1)
		   iWin.setValues(contr.getAgentInfos(selection),selection);     
		else
		   iWin.clearValues();
	    }
	    if (src==SteppingButton)
	    {
	    	int error=0;
	    	int input=1;
	    	System.out.println("Stepping button pressed...");
		try {
                	input=Integer.parseInt(SteppingTF.getText());
                } catch (NumberFormatException ef)
                {
    			error=1;
                }	    	
                
                if ((error==1)||(input<=0))
                {
                   JOptionPane.showMessageDialog(this,
                                  "Please enter valid numbers only.",
                                   "Input error",
                                   JOptionPane.ERROR_MESSAGE);
                }
                else
                   stepping=input;
	    }

	    if ((src==HelpAboutMenuItem)||(src==HelpButton))
	    {
	    	JOptionPane.showMessageDialog(this,
                             "ALGAE simulation\n\n"+
                             "(c) 2000-2001 written by\n"+
                             "Clemens Bauer (cbauer@cosy.sbg.ac.at)\n"+
                             "Michael Liedlgruber (mliedl@cosy.sbg.ac.at)\n"+
                             "Peter Eisenmann (peisen@cosy.sbg.ac.at)\n"+
                             "Thomas Frommwald (tfromm@cosy.sbg.ac.at)\n"+
                             "Daniel Kadir (dkadir@cosy.sbg.ac.at)\n\n"+
                             "Project-Manager: Roland Schwaiger (rschwaig@cosy.sbg.ac.at)",
                             "Information about ALGAE",
                             JOptionPane.INFORMATION_MESSAGE);
	    }
	    
	    if ((src==ANNButton)||(src==ANNWindowItem))
	    {
	    	if (selection==-1)
		   return;
		   
	    	NetViewSource net=(NetViewSource)contr.getAgentByID(selection);
		
		if (annWin==null)
		   annWin=new ANNWindow(net);
		else
		{
		   annWin.dispose();
		   annWin=new ANNWindow(net);
		}
		   
	    	annWin.setResizable(true);
		annWin.setSize(800,200);
		annWin.pack();		
		annWin.setVisible(true);
	    }
	}
	
	public int selected()
	{
		return selection;
	}
	
	public boolean paused()
	{
		return simuPaused;
	}
	
	public boolean stopped()
	{
		return simuStopped;
	}
	
	public boolean viewAlgae()
	{
		return dispAlgaes;
	}
	
	public boolean viewPheromone()
	{
		return dispPhero;
	}
	
	public boolean viewSubstrate()
	{
		return dispSubstrate;
	}
	
	public boolean viewLight()
	{
		return dispLight;
	}
	
	public void setNewAreaDimensions()
	{
		int sx=(int)(aquaScale*(float)config.width);
		int sy=(int)(aquaScale*(float)config.height);
		
		aqua.setPreferredSize(new Dimension(sx, sy));
		scrollPane.setPreferredSize(new Dimension(sx, sy));
		aqua.revalidate();
	}

        public int getStepping() 
        {
	    return stepping;
	}
                 
        public void AddToolBarButtons()
        {
       		/*
        	NewButton.setToolTipText("Start new simulation");
        	toolBar.add(NewButton);

                OpenButton.setPressedIcon(OpenRolloverImg);
                OpenButton.setRolloverIcon(OpenRolloverImg);
                OpenButton.setRolloverEnabled(true);
                OpenButton.setToolTipText("Open a simulation file");
        	toolBar.add(OpenButton);

                SaveButton.setPressedIcon(SaveRolloverImg);
                SaveButton.setRolloverIcon(SaveRolloverImg);
                SaveButton.setRolloverEnabled(true);
        	SaveButton.setToolTipText("Save current simulation file");
        	toolBar.add(SaveButton);
        	
        	toolBar.addSeparator();
		*/
		PlayButton.addActionListener(this);
         	PlayButton.setToolTipText("Start/continue simulation");
        	toolBar.add(PlayButton);
         	PauseButton.addActionListener(this);
        	PauseButton.setToolTipText("Pause simulation");
        	toolBar.add(PauseButton);
        	StepButton.addActionListener(this);
        	StepButton.setToolTipText("Simulate single step");
        	toolBar.add(StepButton);
        	ResetButton.addActionListener(this);
        	ResetButton.setToolTipText("Reset simulation");
        	toolBar.add(ResetButton);
        	
        	toolBar.addSeparator();
        	
        	HelpButton.setToolTipText("Open online help");
                toolBar.add(HelpButton);
                toolBar.addSeparator();
		HelpButton.addActionListener(this);
		
        	ZoomInButton.setToolTipText("Zoom in aquarium view");
        	ZoomInButton.addActionListener(this);
        	toolBar.add(ZoomInButton);
                ZoomOutButton.setToolTipText("Zoom out aquarium view");
                ZoomOutButton.addActionListener(this);
        	toolBar.add(ZoomOutButton);
                toolBar.addSeparator();
                
                ANNButton.setToolTipText("Show ANN for the selected agent");
                ANNButton.addActionListener(this);
        	toolBar.add(ANNButton);
                
      	}

        public void AddSliders()
        {
        	SteppingPanel=new JPanel(new GridLayout(1,25));
        	SteppingPanel.add(SteppingTF);
		SteppingPanel.add(SteppingButton);
		SteppingButton.addActionListener(this);
							
                SpeedSlider = new JSlider(JSlider.HORIZONTAL,0, 50, SimulationDelay);
		SpeedSlider.addChangeListener(new SliderListener());
		SpeedSlider.setMajorTickSpacing(25);
		SpeedSlider.setMinorTickSpacing(10);
		SpeedSlider.setPaintTicks(true);
		SpeedSlider.setPaintLabels(true);

		JLabel SpeedLabel = new JLabel("Simulation Speed", JLabel.CENTER);
        	SpeedLabel.setAlignmentX(Component.CENTER_ALIGNMENT);

		Hashtable SpeedLabelTable = new Hashtable();
          	SpeedLabelTable.put( new Integer( 0 ), new JLabel("Fast") );
          	SpeedLabelTable.put( new Integer( 50 ), new JLabel("Slow") );
          	SpeedSlider.setLabelTable(SpeedLabelTable);
          	SpeedSlider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
                
		JPanel tmp = new JPanel(new GridLayout(1,2));
				
		tmp.add(SteppingPanel);
		tmp.add(SpeedSlider);

		c.gridx = 0;
         	c.gridy = 1;
         	c.gridwidth=6;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.HORIZONTAL;
         	gridbag.setConstraints(tmp, c);
         				
		contentPane.add(tmp);
        }
        
        public void AddCBS()
        {
	        TitledBorder graphborder= BorderFactory.createTitledBorder(BorderFactory.createLoweredBevelBorder(), "Options");
	        JPanel tmp = new JPanel(new GridLayout(6,1));
                
        	tmp.add(DrawAlgaeCB);
		DrawAlgaeCB.setSelected(true);
        	DrawAlgaeCB.addActionListener(this);
         	tmp.add(DrawPheroCB);
		DrawPheroCB.setSelected(true);
         	DrawPheroCB.addActionListener(this);
         	tmp.add(DrawSubstCB);
		DrawSubstCB.setSelected(true);
         	DrawSubstCB.addActionListener(this);
		tmp.add(DrawLightCB);
		DrawLightCB.setSelected(true);
        	DrawLightCB.addActionListener(this);
        	tmp.add(DrawGridCB);
		DrawGridCB.setSelected(true);
        	DrawGridCB.addActionListener(this);
        	
        	AlgList.addActionListener(this);
		tmp.add(AlgList);
		
		c.gridx = 6;
         	c.gridy = 0;
         	c.gridwidth=3;
         	c.gridheight=2;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.HORIZONTAL;
         	gridbag.setConstraints(tmp, c);
		tmp.setBorder(graphborder);
         	contentPane.add(tmp);        	
	}
    
        public void AddToolBar()
        {
		toolBar = new JToolBar();
		toolBar.setFloatable(false);
				
		// toolbar on top of content pane
         	c.gridx = 0;
         	c.gridy = 0;
         	c.gridwidth=6;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
         	gridbag.setConstraints(toolBar, c);
         	contentPane.add(toolBar);
      	}

        public ImagePanel getAqua()
        {
	    return aqua;
	}

        public void AddCanvas()
        {
        	int sx=config.width;
        	int sy=config.height;
        	
        	aqua = new ImagePanel(this);
         	aqua.setBackground(Color.white);
		aqua.setPreferredSize(new Dimension(sx, sy));
		aqua.setDoubleBuffered(true);
	        scrollPane = new JScrollPane(aqua);
                scrollPane.setPreferredSize(new Dimension(sx, sy));
			 
		TitledBorder graphborder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "GRAPH");

		scrollPane.setBorder(graphborder);
                c.gridx = 0;
         	c.gridy = 2;
         	c.gridwidth=9;
         	c.gridheight=6;
         	c.weightx=1.1;
         	c.weighty=1.1;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.BOTH;
		JPanel tmp=new JPanel(new GridLayout(1,1));
		tmp.add(scrollPane);
         	gridbag.setConstraints(tmp, c);
         	contentPane.add(tmp);          	
        }
        
        public void setState(String stat)
        {
        	stateLabel.setText(stat);
        }
        
        public void setStatus(String stat, float light, float subAm, int numAlg, int step, int stepsToDo)
        {
        	setState(stat);
        	lightLabel.setText("Light: "+Float.toString(light));
        	substLabel.setText("Substrate: "+Float.toString(subAm));
        	algaeLabel.setText("# of algaes: "+Integer.toString(numAlg));
        	stepLabel.setText("step "+Integer.toString(step)+" of "+Integer.toString(stepsToDo));
        	progress.setValue(step);
	}

        public void AddStatusBar()
        {
        	statusPanel=new JPanel(new GridLayout(2,6));
		progress=new JProgressBar(0,config.duration);
		progress.setStringPainted(true);        	
        	progress.setValue(0);
        	
        	statusPanel.add(stateLabel);
        	statusPanel.add(lightLabel);
        	statusPanel.add(substLabel);
        	statusPanel.add(algaeLabel);
        	statusPanel.add(stepLabel);
        	statusPanel.add(progress);
        	
        	statusPanel.add(mousePosLabel);
                statusPanel.add(mouseLightLabel);
                statusPanel.add(mouseSubstrateLabel);
                statusPanel.add(mousePheromoneLabel);
                statusPanel.add(mouseAgentLabel);
                statusPanel.add(mouseSelectionLabel);
                	
        	c.gridx = 0;
         	c.gridy = 8;
         	c.gridwidth=9;
         	c.gridheight=1;
         	c.weightx=1;
         	c.weighty=0;
         	c.insets=new Insets(0,0,0,0);
         	c.fill = GridBagConstraints.HORIZONTAL;
         	gridbag.setConstraints(statusPanel, c);
                contentPane.add(statusPanel);          	        	
        }
        
        public void SetupGUI()
        {
        	// assign gridbag-layout to contentpane
        	contentPane.setLayout(gridbag);
        	// add main menu items
        	AddMenuItems();
        	// add toolbar to top of contentpane
        	AddToolBar();
		// add stuff to toolbar
        	AddToolBarButtons();
        	// add Light and Speed sliders
        	AddSliders();
		// Options Checkboxes
		AddCBS();
		// the drawing area
        	AddCanvas();
		// and finally the status bar (simple panel)
        	AddStatusBar();
        }	

    public void reBuildComboItems()
    {
    	/*
    	ViewAgent aList[]=contr.agents.getList();
    	
    	AlgList.removeAllItems();
	for (int z=0; z<aList.length; z++)
 	{
 	    AlgList.addItem(Integer.toString(aList[z].agentID));
 	}
 	*/
    }

    // paint the whole aquarium and update the 1st line of the statusbar
    // (if onlystatus==true, only the statusbar is updated)
    public void paintAll(WorldState w, boolean onlyStatus)
    {
    	if (w.aList==null)
    	    setStatus("running...",(float)w.lightIntensity,(float)w.substrateAmount,0,w.steps,w.stepsToRun);
    	else
    	    setStatus("running...",(float)w.lightIntensity,(float)w.substrateAmount,w.aList.length,w.steps,w.stepsToRun);

	progress.setMaximum(w.stepsToRun);
		
	if (onlyStatus) return;

	Drawing=true;
        		
        // set the agents into the aquarium
	if (w.aList!=null)
	{
	if ((w.aList.length>0)&&(dispAlgaes))
	{
	    int tmpSel = -1;
	    int pos[][]=new int[w.aList.length][4]; 
	    for (int z=0; z<w.aList.length; z++)
 	    {
 		pos[z][0]=w.aList[z].x;
 		pos[z][1]=w.aList[z].y;
 		pos[z][2]=w.aList[z].direction;
 		pos[z][3]=(int)(w.aList[z].energy*255.0f);
 		if (pos[z][3]>255)
 		    pos[z][3]=255;
 		
 		if (selection==w.aList[z].agentID)
 		{
 		   tmpSel=z;
 		   //peisen: System.out.println("paintAll(...): agent selected (aList) = "+tmpSel);
 		}
 		
 		// list agents alive in combobox to make them selectable
 	    }
 	    
 	    //peisen: System.out.println("ALGLIST: paintAll() - selection=tmpSel= "+tmpSel);
 	    if (tmpSel==-1)
 	    {
 	    	selection=-1;
 	    	if (iWin!=null)
 	    	    iWin.clearValues();
		mouseSelectionLabel.setText("Selection: ----");
		 	    	
 	    	//peisen: System.out.println("ALGLIST: No selection made");
 	    }
 	     	    
 	    aqua.setAlgae(tmpSel,pos); 
 	}
	}
	else
	   aqua.clearAList(); 
	Drawing=false;	
	// show infos for selected agent
	if ((iWin!=null)&&(selection!=-1))
        {
             iWin.setValues(contr.getAgentInfos(selection),selection);     
	}
		
	// set the substrate into the aquarium 
	//System.out.println("(...) - substrate...");
	if (w.sList!=null)
	{
	if ((w.sList.length>0)&&(dispSubstrate))
        {
	    int pos[][]=new int[w.sList.length][3];
	    
	    for (int z=0; z<w.sList.length; z++)
	    {
	    	pos[z][0]=w.sList[z].x;
		pos[z][1]=w.sList[z].y;
		pos[z][2]=(int)w.sList[z].amount;
	    }
	    aqua.setSubstrates(pos);
	}
	}
	else
	   aqua.clearSList(); 

	//System.out.println("paintAll(...) - pheromone...");
	// put the pheromones onto the scene
	if (w.pList!=null)
	{
	if ((w.pList.length>0)&&(dispPhero))
        {
            int pos[][]=new int [w.pList.length][3];
	    
	    for (int z=0; z<w.pList.length; z++)
	    {
		pos[z][0]=w.pList[z].x;
		pos[z][1]=w.pList[z].y;
		pos[z][2]=(int)w.pList[z].amount;
	    }
	    aqua.setPheromones(pos);
	}
	}
   	else
   	   aqua.clearPList();	

	// put the pheromones onto the scene
	if (w.lList!=null)
	{
	if ((w.lList.length>0)&&(dispLight))
        {
            int pos[][]=new int [w.lList.length][3];
	    
	    for (int z=0; z<w.lList.length; z++)
	    {
		pos[z][0]=w.lList[z].x;
		pos[z][1]=w.lList[z].y;
		pos[z][2]=(int)(w.lList[z].amount*128);
	    }
	    aqua.setLight(pos);
	}
	}
   	else
   	   aqua.clearLList();	

	// and finally draw all the stuff
	//System.out.println("paintAll(...) - sending everythg to <aqua>...");
	aqua.update(aqua.getGraphics());
	//System.out.println("algen.paintAll(...) drawing [done]");	
    }

    public int likeToContinue(int doneSteps)
    {
	ContinueDlg cDlg=new ContinueDlg(this,doneSteps);
	if (cDlg.getEnteredValue()!=-1)
	    return cDlg.getEnteredValue();
	else
	    return 0;
    }
	
        public MainGUI(Settings set) 
	{
		config=set;
        	addWindowListener(new WindowAdapter() 
        	{
		    public void windowClosing(WindowEvent e) 
            	    {
            	    	if (iWin!=null)
            	    	   iWin.dispose();
		        
            	    	dispose();
			//System.exit(0);		
		    }
        	});

		contr=new GUIWC(set, this);
				
		PauseButton.setEnabled(false);
		SteppingButton.setEnabled(true);
		SteppingTF.setEnabled(true);
	    	ResetButton.setEnabled(true);
	    	StepButton.setEnabled(true);
	    	PlayButton.setEnabled(true);
	    	AlgList.setEnabled(true);
		ZoomOutButton.setEnabled(true);				
		ANNButton.setEnabled(true);
		
        	grayMenuBar = new JMenuBar();
        	grayMenuBar.setOpaque(true);
        	grayMenuBar.setPreferredSize(new Dimension(200, 20));

		SetupGUI();
		aqua.setScale(aquaScale);
		aqua.setWidth(config.width);
		aqua.setHeight(config.height);
		aqua.paintRefresh();
				
	        setStatus("ready...",0,config.substrate_amount,config.initial_algaes,0,config.duration);
												
		timer = new Timer(SimulationDelay*10, new ActionListener() {
		    public void actionPerformed(ActionEvent evt) 
		    {
		    	ws=contr.run();
			if (ws==null)
			{
			    Running=false;
	    	
			    simuPaused=true;
			    simuStopped=false;

			    SteppingButton.setEnabled(true);
			    SteppingTF.setEnabled(true);
			    ResetButton.setEnabled(true);
			    StepButton.setEnabled(true);
			    PauseButton.setEnabled(false);
			    PlayButton.setEnabled(true);
			    AlgList.setEnabled(true);
			    ANNButton.setEnabled(true);
				
			    timer.stop();	    	
			    setState("stopped...");
			}
			else
			{
			    if (stepCount==0)
			    {
				stepCount=stepping-1;
				paintAll(ws,false);
		            }
		            else
		            {
			    	stepCount--;
			    	paintAll(ws,true);
			    }
			}
		    }    
		});
		
        	setJMenuBar(grayMenuBar);
		
        	timer.setCoalesce(false);      	       	
        }
                
        class SliderListener implements ChangeListener {
	    public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)e.getSource();
		if ((source==SpeedSlider))
		{
		    int fps=(int)source.getValue();
		    SimulationDelay=fps;		    
 		    timer.setDelay(fps*10);
 		}
	    }
	}
}

