package algae.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.BorderFactory;
import javax.swing.border.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

import algae.simulation.*;
import algae.gui.*;

import algae.xmlstuff.SettingsImport;
import algae.xmlstuff.SettingsExport;

import java.io.*;
import java.util.*;

class TabbedListener implements ChangeListener {
	public void stateChanged(ChangeEvent e) 
	{
	       	 JTabbedPane source = (JTabbedPane)e.getSource();         
	       	 System.out.println("Another TabbedPane-panel selected...");
        }
}

public final class SettingsDialog extends JFrame implements ActionListener{
    public MainGUI window=null;  // the main simulation window
    JButton OKBtn = new JButton("OK");
    JButton QuitBtn = new JButton("Quit");
    JButton SaveBtn = new JButton("Save");
    JButton LoadBtn = new JButton("Load");
    String []presets={"-----"};
    
    String []lightCycleFuncs={"sin(t)","rectangle(t)","chainsaw(t)","zigzag(t)"};
    String []lightDistFuncs={"1/y"};
    String []substrateDistFuncs={"1/y"};
    String []transferFuncs={"tan","sin","cos","atan","asin","acos"};
    
    JComboBox PresetsCombo = new JComboBox(presets);
    
    JPanel SimulationPanel = new JPanel();
    JPanel AlgaesPanel = new JPanel();
    JPanel SensorsPanel = new JPanel();
    JPanel ActionPanel = new JPanel();
    JPanel ANNPanel = new JPanel();
    JPanel EvolutionPanel = new JPanel();
    JPanel SubstratePanel = new JPanel();
    JPanel LightPanel = new JPanel();

    JPanel ActionTopLeftPanel = new JPanel();
    JPanel ActionBottomLeftPanel = new JPanel();
    JPanel ActionTopRightPanel = new JPanel();
    JPanel ActionBottomRightPanel = new JPanel();

    JTabbedPane TabbedPane = new JTabbedPane();
    
    Container contentPane;

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();

    GridBagLayout gridbag2 = new GridBagLayout();
    GridBagConstraints c2 = new GridBagConstraints();
    
    JPanel TopPanel = new JPanel();
    JPanel BottomPanel = new JPanel();

    JTextField DurationTF = new JTextField(5);
    JTextField WidthTF = new JTextField(3);
    JTextField HeightTF = new JTextField(3);

    JTextField IntensityTF = new JTextField(5);

    JTextField SubstrateAmountTF = new JTextField(5);
    JTextField SubstrateRenewTF = new JTextField(5);
    JTextField Substrate4DeadAgentTF = new JTextField(5);
    JTextField PheroDecreaseTF = new JTextField(5);

    JTextField InitialAlgaesTF = new JTextField(5);
    JTextField InitialEnergyTF = new JTextField(5);

    JTextField RandomSeedTF = new JTextField(5);

    JTextField PheromoneFOVTF = new JTextField(5);
    JTextField PheromoneRangeTF = new JTextField(5);
    JTextField SubstrateFOVTF = new JTextField(5);
    JTextField SubstrateRangeTF = new JTextField(5);
    JTextField LightFOVTF = new JTextField(5);
    JTextField LightRangeTF = new JTextField(5);
    JTextField BumperRangeTF = new JTextField(5);

    JTextField EnergyMovementTF = new JTextField(5);
    JTextField EnergyMitoseTF = new JTextField(5);
    JTextField EnergyMeioseTF = new JTextField(5);
    JTextField EnergyPOutputTF = new JTextField(5);
    JTextField EnergySubstrateTF = new JTextField(5);
    JTextField EnergyLightTF = new JTextField(5);
    JTextField EnergyStandStillTF = new JTextField(5);
    
    JTextField MinEnergyMitoseTF = new JTextField(5);
    JTextField MinEnergyMeioseTF = new JTextField(5);
    JTextField MinEnergyPOutputTF = new JTextField(5);
    JTextField MaxSatPheromoneTF = new JTextField(5);
    JTextField MaxSatSubstrateTF = new JTextField(5);

    JTextField NumberOfNeuronsTF = new JTextField(5);    
    JTextField PheromoneRadiusTF = new JTextField(5);
    JTextField AgentTransluencyTF = new JTextField(5);
    
    JRadioButton AllTheTimeRB = new JRadioButton("Always on");
    JRadioButton FunctionRB = new JRadioButton("Function");
    ButtonGroup enabledGroup = new ButtonGroup();    
    
    JComboBox LightDistFuncCombo = new JComboBox(lightDistFuncs);
    JComboBox LightCycleFuncCombo = new JComboBox(lightCycleFuncs);

    JTextField PeriodicSubstrateAmountTF = new JTextField(5);
    JTextField PeriodicSubstrateStepsTF = new JTextField(5);
    JComboBox SubstrateDistFuncCombo = new JComboBox(substrateDistFuncs);
    JCheckBox LightEnabledCB = new JCheckBox("Enabled");
    JCheckBox PeriodicSubstrateCB = new JCheckBox("Enable periodic substrate input");

    JTextField NumberOfCSNodesTF = new JTextField(5);

    JRadioButton OnePointCrossRB=new JRadioButton("1-point crossover"); 
    JRadioButton TwoPointCrossRB=new JRadioButton("2-point crossover"); 
    JRadioButton NPointCrossRB=new JRadioButton("n-point crossover");
    ButtonGroup CrossGroup=new ButtonGroup();
    JTextField NPointCrossTF=new JTextField(5);

    JTextField AnnMutationRateTF=new JTextField(5);
    JTextField AnnCrossOverRateTF=new JTextField(5);	
    JTextField CsMutationRateTF=new JTextField(5);
    JTextField CsCrossOverRateTF=new JTextField(5);	
    JTextField InitialANNBiasTF=new JTextField(5);

    JComboBox TransferFuncCombo = new JComboBox(transferFuncs);

    JRadioButton CubicSplineRB=new JRadioButton("use cubic splines");
    JRadioButton TransferFuncRB=new JRadioButton("use another transfer function");
    ButtonGroup TransferFuncGroup=new ButtonGroup();
   	

    Settings config; // holds configuration for the current session

    // throw a debug message to System.out
    public void dm(String s)
    {
	System.out.println(s);
    }

    public Settings StoreSettingsToVar()
    {
	Settings c=new Settings();
	// simulation settings
	c.duration=java.lang.Integer.parseInt(DurationTF.getText());
	c.width=java.lang.Integer.parseInt(WidthTF.getText());
	c.height=java.lang.Integer.parseInt(HeightTF.getText());
	c.pheromone_dec_rate=java.lang.Float.parseFloat(PheroDecreaseTF.getText());
	c.randSeed = java.lang.Integer.parseInt(RandomSeedTF.getText());

	// light settings	
	if (AllTheTimeRB.isSelected())
    	    c.light_enabled=1;	
    	else  
	if (FunctionRB.isSelected())
    	    c.light_enabled=2;

	if (!LightEnabledCB.isSelected())
	    c.light_enabled=0;
	
	c.light_intensity=java.lang.Float.parseFloat(IntensityTF.getText());
		
	if (((String)LightDistFuncCombo.getSelectedItem()).equals("1/y"))
	    c.light_function=1;
	else
	    c.light_function=0; // stored func is not defined
	    
	if (((String)LightCycleFuncCombo.getSelectedItem()).equals("sin(t)"))
    	    c.light_cycle_function=1;
	else
	if (((String)LightCycleFuncCombo.getSelectedItem()).equals("rectangle(t)"))
    	    c.light_cycle_function=2;
	else
	if (((String)LightCycleFuncCombo.getSelectedItem()).equals("chainsaw(t)"))
    	    c.light_cycle_function=3;
        else
	if (((String)LightCycleFuncCombo.getSelectedItem()).equals("zigzag(t)"))
    	    c.light_cycle_function=4;
    	else
    	    c.light_cycle_function=0; // stored func is not defined    

	// substrate settings
	c.substrate_amount=java.lang.Integer.parseInt(SubstrateAmountTF.getText());
	c.substrate_renew_rate=java.lang.Float.parseFloat(SubstrateRenewTF.getText());
	c.substrate_for_dead_agent=java.lang.Float.parseFloat(Substrate4DeadAgentTF.getText());
	
	if (PeriodicSubstrateCB.isSelected())
	{
	   c.substrate_periodic_amount=java.lang.Integer.parseInt(PeriodicSubstrateAmountTF.getText());		
	   c.substrate_periodic_steps=java.lang.Integer.parseInt(PeriodicSubstrateStepsTF.getText());
	}
	
	// TODO: add more functions
	c.substrate_function=0;
	
	if (PeriodicSubstrateCB.isSelected())
	   c.periodic_substrate=1;	
	else
	   c.periodic_substrate=0;		
	
	// algaes settings
	c.initial_algaes=java.lang.Integer.parseInt(InitialAlgaesTF.getText());
	c.initial_energy=java.lang.Float.parseFloat(InitialEnergyTF.getText());
        c.agent_transluency=java.lang.Float.parseFloat(AgentTransluencyTF.getText());
	c.pheromone_radius=java.lang.Float.parseFloat(PheromoneRadiusTF.getText());

	// sensors settings
	c.pheromone_fov=java.lang.Integer.parseInt(PheromoneFOVTF.getText());
	c.pheromone_range=java.lang.Integer.parseInt(PheromoneRangeTF.getText());
	c.substrate_fov=java.lang.Integer.parseInt(SubstrateFOVTF.getText());
	c.substrate_range=java.lang.Integer.parseInt(SubstrateRangeTF.getText());	
	c.light_fov=java.lang.Integer.parseInt(LightFOVTF.getText());
	c.light_range=java.lang.Integer.parseInt(LightRangeTF.getText());
	c.bumper_range=java.lang.Integer.parseInt(BumperRangeTF.getText());

   	// actions settings
        c.energy_movement=java.lang.Float.parseFloat(EnergyMovementTF.getText());
	c.energy_mitose=java.lang.Float.parseFloat(EnergyMitoseTF.getText());
	c.energy_meiose=java.lang.Float.parseFloat(EnergyMeioseTF.getText());
	c.energy_pheromone_output=java.lang.Float.parseFloat(EnergyPOutputTF.getText());
	c.energy_substrate=java.lang.Float.parseFloat(EnergySubstrateTF.getText());
	c.energy_light=java.lang.Float.parseFloat(EnergyLightTF.getText());
 	c.energy_standstill=java.lang.Float.parseFloat(EnergyStandStillTF.getText());
 
        c.min_energy_mitose=java.lang.Float.parseFloat(MinEnergyMitoseTF.getText());
	c.min_energy_meiose=java.lang.Float.parseFloat(MinEnergyMeioseTF.getText());
	c.min_energy_pheromone_output=java.lang.Float.parseFloat(MinEnergyPOutputTF.getText());
	
	c.max_pheromone_saturation=java.lang.Float.parseFloat(MaxSatPheromoneTF.getText());
	c.max_substrate_saturation=java.lang.Float.parseFloat(MaxSatSubstrateTF.getText());

	// ANN settings
        c.number_of_neurons=java.lang.Integer.parseInt(NumberOfNeuronsTF.getText()); 
        c.initial_ann_bias=java.lang.Float.parseFloat(InitialANNBiasTF.getText()); 
        
	if (CubicSplineRB.isSelected())
	{
	   c.spline_node_count=java.lang.Integer.parseInt(NumberOfCSNodesTF.getText());
	   c.ann_transfer_func=-1;
	}
	else
	{
	   c.spline_node_count=-1;
	   String tmp=(String)TransferFuncCombo.getSelectedItem();
	   //String []transferFuncs={"tan","sin","cos","atan","asin","acos"};	   
	   if (tmp.equals("tan")) c.ann_transfer_func=1;
	   if (tmp.equals("sin")) c.ann_transfer_func=2;
	   if (tmp.equals("cos")) c.ann_transfer_func=3;
	   if (tmp.equals("atan")) c.ann_transfer_func=4;
	   if (tmp.equals("asin")) c.ann_transfer_func=5;
	   if (tmp.equals("acos")) c.ann_transfer_func=6;
	}
	
	// evolution settings
	if (OnePointCrossRB.isSelected())
	   c.crossover_type=1;
	else
	if (TwoPointCrossRB.isSelected())
	   c.crossover_type=2;
	else
	   c.crossover_type=java.lang.Integer.parseInt(NPointCrossTF.getText());
	
	c.ann_mutation_rate=java.lang.Float.parseFloat(AnnMutationRateTF.getText());
        c.ann_crossover_rate=java.lang.Float.parseFloat(AnnCrossOverRateTF.getText());
	c.cs_mutation_rate=java.lang.Float.parseFloat(CsMutationRateTF.getText());
        c.cs_crossover_rate=java.lang.Float.parseFloat(CsCrossOverRateTF.getText());
    	
	return c;
    }

    public void StoreSettingsToGUI(Settings c)
    {
	// simulation settings
	DurationTF.setText(Integer.toString(c.duration));
	WidthTF.setText(Integer.toString(c.width));
	HeightTF.setText(Integer.toString(c.height));
	PheroDecreaseTF.setText(Float.toString(c.pheromone_dec_rate));
	RandomSeedTF.setText(Integer.toString(c.randSeed));

	// light settings	
	AllTheTimeRB.setSelected(false);
    	FunctionRB.setSelected(false);    	
    	switch (c.light_enabled)
	{
	  case 0: LightEnabledCB.setSelected(false); break;
	  case 1: AllTheTimeRB.setSelected(true); break;
	  case 2: FunctionRB.setSelected(true); 
	}
	IntensityTF.setText(Float.toString(c.light_intensity));
		
	switch (c.light_function)
	{
	  case 0: break;
	  case 1: LightDistFuncCombo.setSelectedItem((Object)"1/y");
	}
	    
	switch (c.light_cycle_function)
	{
	  case 0: break;
	  case 1: LightCycleFuncCombo.setSelectedItem((Object)"sin(t)"); break;
	  case 2: LightCycleFuncCombo.setSelectedItem((Object)"rectangle(t)"); break;
	  case 3: LightCycleFuncCombo.setSelectedItem((Object)"chainsaw(t)"); break;
	  case 4: LightCycleFuncCombo.setSelectedItem((Object)"zigzag(t)"); 
	}
		
	// substrate settings
	SubstrateAmountTF.setText(Integer.toString(c.substrate_amount));
	SubstrateRenewTF.setText(Float.toString(c.substrate_renew_rate));
	Substrate4DeadAgentTF.setText(Float.toString(c.substrate_for_dead_agent));

	if (c.periodic_substrate==1)
	{
	    PeriodicSubstrateCB.setSelected(true);	    
	    PeriodicSubstrateAmountTF.setEnabled(true);
	    PeriodicSubstrateStepsTF.setEnabled(true);  	    	
	    SubstrateDistFuncCombo.setEnabled(false);
	}
	else
	{
	    PeriodicSubstrateCB.setSelected(false);
	    PeriodicSubstrateAmountTF.setEnabled(false);
	    PeriodicSubstrateStepsTF.setEnabled(false);  		    	
	    SubstrateDistFuncCombo.setEnabled(true);
	}  
	
	if (PeriodicSubstrateCB.isSelected())
	{
	   PeriodicSubstrateAmountTF.setText(Integer.toString(c.substrate_periodic_amount));		
	   PeriodicSubstrateStepsTF.setText(Integer.toString(c.substrate_periodic_steps));
	}
	else
	{
	   PeriodicSubstrateAmountTF.setText("0");		
	   PeriodicSubstrateStepsTF.setText("0");
	}
	
	SubstrateDistFuncCombo.setSelectedIndex(c.substrate_function);
		
	// algaes settings
	InitialAlgaesTF.setText(Integer.toString(c.initial_algaes));
	InitialEnergyTF.setText(Float.toString(c.initial_energy));
        AgentTransluencyTF.setText(Float.toString(c.agent_transluency));
	PheromoneRadiusTF.setText(Float.toString(c.pheromone_radius));

	// sensors settings
	PheromoneFOVTF.setText(Integer.toString(c.pheromone_fov));
	PheromoneRangeTF.setText(Integer.toString(c.pheromone_range));
	SubstrateFOVTF.setText(Integer.toString(c.substrate_fov));
	SubstrateRangeTF.setText(Integer.toString(c.substrate_range));	
	LightFOVTF.setText(Integer.toString(c.light_fov));
	LightRangeTF.setText(Integer.toString(c.light_range));
	BumperRangeTF.setText(Integer.toString(c.bumper_range));

   	// actions settings
        EnergyMovementTF.setText(Float.toString(c.energy_movement));
	EnergyMitoseTF.setText(Float.toString(c.energy_mitose));
	EnergyMeioseTF.setText(Float.toString(c.energy_meiose));
	EnergyPOutputTF.setText(Float.toString(c.energy_pheromone_output));
	EnergySubstrateTF.setText(Float.toString(c.energy_substrate));
	EnergyLightTF.setText(Float.toString(c.energy_light));
 	EnergyStandStillTF.setText(Float.toString(c.energy_standstill));
 
        MinEnergyMitoseTF.setText(Float.toString(c.min_energy_mitose));
	MinEnergyMeioseTF.setText(Float.toString(c.min_energy_meiose));
	MinEnergyPOutputTF.setText(Float.toString(c.min_energy_pheromone_output));
	
	MaxSatPheromoneTF.setText(Float.toString(c.max_pheromone_saturation));
	MaxSatSubstrateTF.setText(Float.toString(c.max_substrate_saturation));

	// ANN settings
        NumberOfNeuronsTF.setText(Integer.toString(c.number_of_neurons)); 
        InitialANNBiasTF.setText(Float.toString(c.initial_ann_bias)); 
        
        if (c.spline_node_count!=-1)
	{
	   NumberOfCSNodesTF.setText(Integer.toString(c.spline_node_count));
	}
	else
	{
	   switch (c.ann_transfer_func)
	   {
	     case 1: TransferFuncCombo.setSelectedItem((Object)"tan"); break;
	     case 2: TransferFuncCombo.setSelectedItem((Object)"sin"); break;
	     case 3: TransferFuncCombo.setSelectedItem((Object)"cos"); break;
	     case 4: TransferFuncCombo.setSelectedItem((Object)"atan"); break;
	     case 5: TransferFuncCombo.setSelectedItem((Object)"asin"); break;
	     case 6: TransferFuncCombo.setSelectedItem((Object)"acos"); 
	   }
	}
	
	if (c.spline_node_count==-1)
	{
	    CubicSplineRB.setSelected(false);
	    TransferFuncRB.setSelected(true);
	    NumberOfCSNodesTF.setText(" ");

	    NumberOfCSNodesTF.setEnabled(false);
	    TransferFuncCombo.setEnabled(true);
	}
	else
	{
	    NumberOfCSNodesTF.setEnabled(true);
	    TransferFuncCombo.setEnabled(false);

	    CubicSplineRB.setSelected(true);
	    TransferFuncRB.setSelected(false);
	    NumberOfCSNodesTF.setText(Integer.toString(c.spline_node_count));
	}
	
	switch (c.crossover_type)
	{
	  case 1: OnePointCrossRB.setSelected(true); break;
	  case 2: TwoPointCrossRB.setSelected(true); break;
	  default : NPointCrossTF.setText(Integer.toString(c.crossover_type));
	}   
	
	AnnMutationRateTF.setText(Float.toString(c.ann_mutation_rate));
        AnnCrossOverRateTF.setText(Float.toString(c.ann_crossover_rate));
	CsMutationRateTF.setText(Float.toString(c.cs_mutation_rate));
        CsCrossOverRateTF.setText(Float.toString(c.cs_crossover_rate));
            	    	
    	IntensityTF.setText(Float.toString(c.light_intensity));
    	
    	if (c.light_function>=1)
    	   LightDistFuncCombo.setSelectedIndex(c.light_function-1);
	LightCycleFuncCombo.setSelectedIndex(c.light_cycle_function+1);
    
	if (c.crossover_type==1)
	{
	    OnePointCrossRB.setSelected(true);
	    TwoPointCrossRB.setSelected(false);
	    NPointCrossRB.setSelected(false);
	    NPointCrossTF.setEnabled(false);
	}
	else 
	if (c.crossover_type==2)
	{
	    OnePointCrossRB.setSelected(false);
	    TwoPointCrossRB.setSelected(true);
	    NPointCrossRB.setSelected(false);
	    NPointCrossTF.setEnabled(false);
	}
	else
	{
	    NPointCrossTF.setEnabled(true);
	    NPointCrossTF.setText(Integer.toString(c.crossover_type));
	    OnePointCrossRB.setSelected(false);
	    TwoPointCrossRB.setSelected(false);
	    NPointCrossRB.setSelected(true);
	}      
        
        boolean tmp=LightEnabledCB.isSelected();
	AllTheTimeRB.setEnabled(tmp);
	FunctionRB.setEnabled(tmp);
	LightDistFuncCombo.setEnabled(tmp);
	IntensityTF.setEnabled(tmp);
		
	if (!tmp)
	{
	   LightCycleFuncCombo.setEnabled(false); 	
	}
	else
	{
	   if (AllTheTimeRB.isSelected())
	       LightCycleFuncCombo.setEnabled(false); 	
	   else
	       LightCycleFuncCombo.setEnabled(true); 	
	}
	
	LightCycleFuncCombo.setEnabled(!AllTheTimeRB.isSelected());	
    }

    public void MakeSimulationPanel()
    {
	GridBagLayout lBag = new GridBagLayout();
	GridBagConstraints lc = new GridBagConstraints();
	SimulationPanel.setLayout(lBag);
	
	// Duration stuff
	JLabel DurationLabel=new JLabel("Duration");
	lc.gridx = 1;
        lc.gridy = 1;
        lc.gridwidth=5;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(DurationLabel, lc);
	SimulationPanel.add(DurationLabel);

	lc.gridx = 1;
        lc.gridy = 2;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(DurationTF, lc);
	SimulationPanel.add(DurationTF);

	JLabel StepsLabel = new JLabel("steps");
	lc.gridx = 5;
        lc.gridy = 2;
        lc.gridwidth=2;
        lc.gridheight=1;
        lBag.setConstraints(StepsLabel, lc);
	SimulationPanel.add(StepsLabel);

	// Dimension stuff
	JLabel DimensionLabel = new JLabel("Dimension");
	lc.gridx = 11;
        lc.gridy = 1;
        lc.gridwidth=8;
        lc.gridheight=1;
        lBag.setConstraints(DimensionLabel, lc);
	SimulationPanel.add(DimensionLabel);
	
	JLabel WidthLabel = new JLabel("Width");
	lc.gridx = 11;
	lc.gridy = 2;
	lc.gridwidth = 2;
	lc.gridheight = 1;
	lBag.setConstraints(WidthLabel, lc);
	SimulationPanel.add(WidthLabel);

	lc.gridx = 13;
	lc.gridy = 2;
	lc.gridwidth = 3;
	lc.gridheight = 1;
	lBag.setConstraints(WidthTF, lc);
	SimulationPanel.add(WidthTF);

	JLabel HeightLabel = new JLabel("Height");
	lc.gridx = 16;
	lc.gridy = 2;
	lc.gridwidth = 3;
	lc.gridheight = 1;
	lBag.setConstraints(HeightLabel, lc);
	SimulationPanel.add(HeightLabel);

	lc.gridx = 19;
	lc.gridy = 2;
	lc.gridwidth = 3;
	lc.gridheight = 1;
	lBag.setConstraints(HeightTF, lc);
	SimulationPanel.add(HeightTF);

	JLabel PheroDecLabel = new JLabel("Pheromone decrease rate");
	lc.gridx = 0;
        lc.gridy = 5;
        lc.gridwidth=10;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(PheroDecLabel, lc);
	SimulationPanel.add(PheroDecLabel);

	lc.gridx = 10;
        lc.gridy = 5;
        lc.gridwidth=5;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(PheroDecreaseTF, lc);
	SimulationPanel.add(PheroDecreaseTF);

	JLabel RandSeedLabel = new JLabel("Random seed");
	lc.gridx = 0;
        lc.gridy = 10;
        lc.gridwidth=10;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(RandSeedLabel, lc);
	SimulationPanel.add(RandSeedLabel);

	lc.gridx = 10;
        lc.gridy = 10;
        lc.gridwidth=5;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(RandomSeedTF, lc);
	SimulationPanel.add(RandomSeedTF);
    }

    public void MakeAlgaesPanel()
    {
	GridBagLayout lBag = new GridBagLayout();
	GridBagConstraints lc = new GridBagConstraints();
	AlgaesPanel.setLayout(lBag);
	
	// Number of initial Algaes - stuff
	JLabel InitialAlgaesLabel=new JLabel("# of initial Algaes");
	lc.gridx = 1;
        lc.gridy = 1;
        lc.gridwidth=8;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(InitialAlgaesLabel, lc);
	AlgaesPanel.add(InitialAlgaesLabel);

	lc.gridx = 1;
        lc.gridy = 2;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(InitialAlgaesTF, lc);
	AlgaesPanel.add(InitialAlgaesTF);

	// initial Energylevel  - stuff
	JLabel InitialEnergyLabel=new JLabel("Initial Energylevel");
	lc.gridx = 11;
        lc.gridy = 1;
        lc.gridwidth=10;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(InitialEnergyLabel, lc);
	AlgaesPanel.add(InitialEnergyLabel);

	lc.gridx = 11;
        lc.gridy = 2;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(InitialEnergyTF, lc);
	AlgaesPanel.add(InitialEnergyTF);
	
	// put stuff for pheromone radius onto the panel
	JLabel PheroRadLabel=new JLabel("Radius of pheromone output");
	lc.gridx = 1;
        lc.gridy = 3;
        lc.gridwidth=15;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(PheroRadLabel, lc);
	AlgaesPanel.add(PheroRadLabel);

	lc.gridx = 16;
        lc.gridy = 3;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(PheromoneRadiusTF, lc);
	AlgaesPanel.add(PheromoneRadiusTF);
	
	// put stuff for agent transluency onto the panel
	JLabel TransLabel=new JLabel("Transluency factor for an agent");
	lc.gridx = 1;
        lc.gridy = 5;
        lc.gridwidth=15;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(5,5,5,5);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(TransLabel, lc);
	AlgaesPanel.add(TransLabel);

	lc.gridx = 16;
        lc.gridy = 5;
        lc.gridwidth=4;
        lc.gridheight=1;
        lBag.setConstraints(AgentTransluencyTF, lc);
	AlgaesPanel.add(AgentTransluencyTF);	
    }

    public void MakeSensorsPanel()
    {
        SensorsPanel.setLayout(new GridLayout(5,3));
	
	// Number of initial Algaes - stuff
	JLabel FOVLabel=new JLabel("FOV");
	JLabel RangeLabel=new JLabel("Range");
	JLabel PheromoneLabel=new JLabel("Pheromone");
	JLabel SubstrateLabel=new JLabel("Substrate");
	JLabel LightLabel=new JLabel("Light");
	JLabel EmptyLabel=new JLabel("  ");	
        JLabel EmptyLabel2=new JLabel("  "); 
        JLabel BumperLabel=new JLabel("Bumper");

	SensorsPanel.add(EmptyLabel);
	SensorsPanel.add(FOVLabel);
	SensorsPanel.add(RangeLabel);

	SensorsPanel.add(PheromoneLabel);
	SensorsPanel.add(PheromoneFOVTF);
	SensorsPanel.add(PheromoneRangeTF);

	SensorsPanel.add(SubstrateLabel);
	SensorsPanel.add(SubstrateFOVTF);
	SensorsPanel.add(SubstrateRangeTF);

	SensorsPanel.add(LightLabel);
	SensorsPanel.add(LightFOVTF);
	SensorsPanel.add(LightRangeTF);

        SensorsPanel.add(BumperLabel);
        SensorsPanel.add(EmptyLabel2);
        SensorsPanel.add(BumperRangeTF);
    }

    public void MakeActionsPanel()
    {
	ActionPanel.setLayout(gridbag2);

	// build up ...
	ActionTopLeftPanel.setLayout(new GridLayout(5,2));
	ActionBottomLeftPanel.setLayout(new GridLayout(2,2));
	ActionTopRightPanel.setLayout(new GridLayout(4,2));
	ActionBottomRightPanel.setLayout(new GridLayout(2,2));
		
        TitledBorder TopLeftBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Energy consumption");
	TitledBorder BottomLeftBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Energy collecting");
        TitledBorder TopRightBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Required energylevels");
	TitledBorder BottomRightBorder= BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "element limits");

	ActionTopLeftPanel.setBorder(TopLeftBorder);
 	ActionBottomLeftPanel.setBorder(BottomLeftBorder);
        ActionTopRightPanel.setBorder(TopRightBorder);
	ActionBottomRightPanel.setBorder(BottomRightBorder);

	JLabel EmptyLabel = new JLabel("  ");
	JLabel MovementLabel = new JLabel("Movement");
	JLabel MitoseLabel = new JLabel("Mitosis");
	JLabel MeioseLabel = new JLabel("Meiosis");
	JLabel PheromoneLabel = new JLabel("Pheromone output");
	JLabel SubstrateLabel = new JLabel("Substrate");
	JLabel LightLabel = new JLabel("Light");
	JLabel StandStillLabel = new JLabel("Stand still");

	ActionTopLeftPanel.add(MovementLabel);
	ActionTopLeftPanel.add(EnergyMovementTF);
	ActionTopLeftPanel.add(MitoseLabel);
	ActionTopLeftPanel.add(EnergyMitoseTF);
	ActionTopLeftPanel.add(MeioseLabel);
	ActionTopLeftPanel.add(EnergyMeioseTF);
	ActionTopLeftPanel.add(PheromoneLabel);
	ActionTopLeftPanel.add(EnergyPOutputTF);
	ActionTopLeftPanel.add(StandStillLabel);
	ActionTopLeftPanel.add(EnergyStandStillTF);

	ActionBottomLeftPanel.add(SubstrateLabel);
	ActionBottomLeftPanel.add(EnergySubstrateTF);
	ActionBottomLeftPanel.add(LightLabel);
	ActionBottomLeftPanel.add(EnergyLightTF);

        ActionTopRightPanel.add(new JLabel("for mitosis")); 
        ActionTopRightPanel.add(MinEnergyMitoseTF); 
        ActionTopRightPanel.add(new JLabel("for meiosis")); 
        ActionTopRightPanel.add(MinEnergyMeioseTF); 
        ActionTopRightPanel.add(new JLabel("for pheromone output")); 
        ActionTopRightPanel.add(MinEnergyPOutputTF); 
	ActionTopRightPanel.add(new JLabel(""));
	ActionTopRightPanel.add(new JLabel(""));

	ActionBottomRightPanel.add(new JLabel("Max. pheromone saturation"));
        ActionBottomRightPanel.add(MaxSatPheromoneTF);
	ActionBottomRightPanel.add(new JLabel("Max. substrate saturation"));
        ActionBottomRightPanel.add(MaxSatSubstrateTF);

	c2.gridx = 0;
        c2.gridy = 0;
        c2.gridwidth=10;
        c2.gridheight=6;
        c2.weightx=1;
        c2.weighty=1;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(ActionTopLeftPanel, c2);
        ActionPanel.add(ActionTopLeftPanel);

	c2.gridx = 0;
        c2.gridy = 6;
        c2.gridwidth=10;
        c2.gridheight=3;
        c2.weightx=1;
        c2.weighty=1;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(ActionBottomLeftPanel, c2);
        ActionPanel.add(ActionBottomLeftPanel);	
        
        c2.gridx = 10;
        c2.gridy = 0;
        c2.gridwidth=10;
        c2.gridheight=6;
        c2.weightx=1;
        c2.weighty=1;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(ActionTopRightPanel, c2);
        ActionPanel.add(ActionTopRightPanel);

	c2.gridx = 10;
        c2.gridy = 6;
        c2.gridwidth=10;
        c2.gridheight=3;
        c2.weightx=1;
        c2.weighty=1;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(ActionBottomRightPanel, c2);
        ActionPanel.add(ActionBottomRightPanel);	
    }

    public void MakeANNPanel()
    {
    	ANNPanel.setLayout(gridbag2);
	
	TitledBorder GeneralBorder=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "General");
	JPanel cPanel=new JPanel();
	//cPanel.setBorder(GeneralBorder);
	cPanel.setLayout(new GridLayout(2,2));
	
	cPanel.add(new JLabel("Number of neurons"));
	cPanel.add(NumberOfNeuronsTF);
	cPanel.add(new JLabel("Initial ANN bias"));
	cPanel.add(InitialANNBiasTF);
	
	c2.gridx = 0;
        c2.gridy = 0;
        c2.gridwidth=10;
        c2.gridheight=1;
        c2.weightx=0;
        c2.weighty=0;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(cPanel, c2);
        ANNPanel.add(cPanel);       

	
	c2.gridx = 0;
        c2.gridy = 1;
        c2.gridwidth=10;
        c2.gridheight=1;
        c2.weightx=0;
        c2.weighty=0;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(CubicSplineRB, c2);
        ANNPanel.add(CubicSplineRB);       
       
	TitledBorder cPanel2Border=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Cubic splines settings");	
	JPanel cPanel2=new JPanel();
	cPanel2.setLayout(new GridLayout(1,2)); 
	cPanel2.setBorder(cPanel2Border);
	
        cPanel2.add(new JLabel("Number of cubic spline nodes"));
	cPanel2.add(NumberOfCSNodesTF);
	c2.gridx = 0;
        c2.gridy = 2;
        c2.gridwidth=10;
        c2.gridheight=1;
        c2.weightx=0;
        c2.weighty=0;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(cPanel2, c2);
        ANNPanel.add(cPanel2);       

	c2.gridx = 0;
        c2.gridy = 3;
        c2.gridwidth=10;
        c2.gridheight=1;
        c2.weightx=0;
        c2.weighty=0;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(TransferFuncRB, c2);
        ANNPanel.add(TransferFuncRB);       
       
	TitledBorder cPanel3Border=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Function");	
	JPanel cPanel3=new JPanel();
	cPanel3.setLayout(new GridLayout(1,2)); 
	cPanel3.setBorder(cPanel3Border);
	cPanel3.add(new JLabel("ANN transfer function"));
	cPanel3.add(TransferFuncCombo);
	
	c2.gridx = 0;
        c2.gridy = 4;
        c2.gridwidth=10;
        c2.gridheight=1;
        c2.weightx=0;
        c2.weighty=0;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(cPanel3, c2);
        ANNPanel.add(cPanel3);       
	
	TransferFuncGroup.add(CubicSplineRB);       
	TransferFuncGroup.add(TransferFuncRB);       
	
	CubicSplineRB.addActionListener(this);
	TransferFuncRB.addActionListener(this);
	TransferFuncCombo.setEnabled(false);
	
	CubicSplineRB.setSelected(true);
    }
    
    public void MakeEvolutionPanel()
    {
    	EvolutionPanel.setLayout(gridbag2);
	
	// Crossover type
	JPanel crossPanel=new JPanel();
        TitledBorder CrossBorder=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Crossover type");
        crossPanel.setBorder(CrossBorder);
        crossPanel.setLayout(new GridLayout(3,2));
        
        crossPanel.add(OnePointCrossRB); 
        crossPanel.add(new JLabel(""));
        crossPanel.add(TwoPointCrossRB); 
        crossPanel.add(new JLabel(""));
     	crossPanel.add(NPointCrossRB);   
     	crossPanel.add(NPointCrossTF);
	
	OnePointCrossRB.addActionListener(this);
	TwoPointCrossRB.addActionListener(this);
	NPointCrossRB.addActionListener(this);
	
	CrossGroup.add(OnePointCrossRB);
	CrossGroup.add(TwoPointCrossRB);
	CrossGroup.add(NPointCrossRB);
	
	OnePointCrossRB.setSelected(true);
	NPointCrossTF.setEnabled(false);
	
	c2.gridx = 0;
        c2.gridy = 0;
        c2.gridwidth=5;
        c2.gridheight=3;
        c2.weightx=0;
        c2.weighty=0;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(crossPanel, c2);
        EvolutionPanel.add(crossPanel);
        
        // Crossover type
	JPanel evoRatesPanel=new JPanel();
        TitledBorder RatesBorder=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Evolution rates");
        evoRatesPanel.setBorder(RatesBorder);
        evoRatesPanel.setLayout(new GridLayout(4,2));
        evoRatesPanel.add(new JLabel("ANN mutation rate"));
        evoRatesPanel.add(AnnMutationRateTF);
	evoRatesPanel.add(new JLabel("ANN crossover rate"));
        evoRatesPanel.add(AnnCrossOverRateTF);
        evoRatesPanel.add(new JLabel("CS mutation rate"));
        evoRatesPanel.add(CsMutationRateTF);
	evoRatesPanel.add(new JLabel("CS crossover rate"));
        evoRatesPanel.add(CsCrossOverRateTF);

	c2.gridx = 5;
        c2.gridy = 0;
        c2.gridwidth=5;
        c2.gridheight=2;
        c2.weightx=0;
        c2.weighty=0;
        c2.insets=new Insets(2,2,2,2);
        c2.fill = GridBagConstraints.BOTH;
        gridbag2.setConstraints(evoRatesPanel, c2);
        EvolutionPanel.add(evoRatesPanel);

    }

    public void MakeSubstratePanel()
    {
	TitledBorder GeneralBorder=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Perodic substrate input");
	TitledBorder GeneralBorder2=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Function based substrate input");
	
	GridBagLayout lBag = new GridBagLayout();
	GridBagConstraints lc = new GridBagConstraints();
	SubstratePanel.setLayout(lBag);

	JPanel DummyPanel=new JPanel();
	DummyPanel.setLayout(new GridLayout(3,2));

	DummyPanel.add(new JLabel("Initial substrate amount"));
	DummyPanel.add(SubstrateAmountTF);
	DummyPanel.add(new JLabel("Substrate for dead agent"));
        DummyPanel.add(Substrate4DeadAgentTF);
	DummyPanel.add(new JLabel("Substrate renew rate"));        
	DummyPanel.add(SubstrateRenewTF);
        
	lc.gridx = 0;
        lc.gridy = 0;
        lc.gridwidth=6;
        lc.gridheight=3;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(2,2,2,2);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(DummyPanel,lc);
        SubstratePanel.add(DummyPanel);
        
        lc.gridx = 0;
        lc.gridy = 3;
        lc.gridwidth=6;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(2,2,2,2);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(PeriodicSubstrateCB,lc);
        SubstratePanel.add(PeriodicSubstrateCB);
	PeriodicSubstrateCB.addActionListener(this);	
                      
	JPanel Dummy2 = new JPanel();
	Dummy2.setBorder(GeneralBorder);
	Dummy2.setLayout(new GridLayout(2,3));
	
	Dummy2.add(new JLabel("amount"));
	Dummy2.add(PeriodicSubstrateAmountTF);
	Dummy2.add(new JLabel(""));
	PeriodicSubstrateAmountTF.setEnabled(false);
	
	Dummy2.add(new JLabel("every"));
	Dummy2.add(PeriodicSubstrateStepsTF);
	Dummy2.add(new JLabel("steps"));	
	PeriodicSubstrateStepsTF.setEnabled(false);
	
	lc.gridx = 0;
        lc.gridy = 4;
        lc.gridwidth=6;
        lc.gridheight=4;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(2,2,2,2);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(Dummy2,lc);
        SubstratePanel.add(Dummy2);
        
        JPanel Dummy3 = new JPanel();
	Dummy3.setBorder(GeneralBorder2);
	Dummy3.setLayout(new GridLayout(1,2));
	
	Dummy3.add(new JLabel("Regeneration function"));
	Dummy3.add(SubstrateDistFuncCombo);	
	lc.gridx = 0;
        lc.gridy = 8;
        lc.gridwidth=6;
        lc.gridheight=2;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(2,2,2,2);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(Dummy3,lc);
        SubstratePanel.add(Dummy3);
    }

    public void MakeLightPanel()
    {
	TitledBorder GeneralBorder=BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.black), "Light cycle");
	
	GridBagLayout lBag = new GridBagLayout();
	GridBagConstraints lc = new GridBagConstraints();
	LightPanel.setLayout(lBag);
	
	JPanel DummyPanel = new JPanel();
	DummyPanel.setLayout(new GridLayout(1,2));

	LightEnabledCB.setSelected(true);
	DummyPanel.add(LightEnabledCB);
	LightEnabledCB.addActionListener(this);	
	DummyPanel.add(new JLabel(""));

	lc.gridx = 0;
        lc.gridy = 0;
        lc.gridwidth=6;
        lc.gridheight=1;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(2,2,2,2);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(DummyPanel,lc);
        LightPanel.add(DummyPanel);

	JPanel Dummy2=new JPanel();
	Dummy2.setBorder(GeneralBorder);
	Dummy2.setLayout(new GridLayout(2,2));

	AllTheTimeRB.setSelected(true);
	enabledGroup.add(AllTheTimeRB);
	enabledGroup.add(FunctionRB);
	AllTheTimeRB.addActionListener(this);	
	FunctionRB.addActionListener(this);	
	
	Dummy2.add(AllTheTimeRB);
       	Dummy2.add(new JLabel(""));
	Dummy2.add(FunctionRB);
	Dummy2.add(LightCycleFuncCombo);
	LightCycleFuncCombo.setEnabled(false); 	
	
	lc.gridx = 0;
        lc.gridy = 1;
        lc.gridwidth=6;
        lc.gridheight=3;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(2,2,2,2);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(Dummy2,lc);
        LightPanel.add(Dummy2);

	JPanel Dummy3=new JPanel();
	Dummy3.setLayout(new GridLayout(2,2));
	Dummy3.add(new JLabel("Intensity"));
	Dummy3.add(IntensityTF);
	Dummy3.add(new JLabel("Distribution function"));
	Dummy3.add(LightDistFuncCombo);

	lc.gridx = 0;
        lc.gridy = 4;
        lc.gridwidth=6;
        lc.gridheight=2;
        lc.weightx=0;
        lc.weighty=0;
        lc.insets=new Insets(2,2,2,2);
        lc.fill = GridBagConstraints.BOTH;
        lBag.setConstraints(Dummy3,lc);
        LightPanel.add(Dummy3);
    }

    /*
    public void mouseClicked(MouseEvent e) {
 	Object src=e.getSource();

  	if (src==TabbedPane)
  	{
  	    System.out.println("Something ;)\n");
   	}
    } 
    */
                
    public void ExportSettingsFile()
    {
	JFileChooser saveas_dialog = new JFileChooser("." + java.io.File.separator + "models"); // Should go to a global variable ?!?
        saveas_dialog.setFileFilter(new XMLFileFilter());
         
        if (saveas_dialog.showDialog(new JFrame(),"Save as...") != JFileChooser.APPROVE_OPTION) 
            return;
            
        SettingsExport sExport=new SettingsExport();       
        sExport.exportSettingsFile(saveas_dialog.getSelectedFile(),StoreSettingsToVar());        
    } 
        
    public boolean DialogImportSettingsFile()
    {
    	JFileChooser open_dialog = new JFileChooser(new File(".")); // Should go to a global variable ?!?
        open_dialog.setFileFilter(new XMLFileFilter());
         
        if (open_dialog.showDialog(new JFrame(),"Load file...") != JFileChooser.APPROVE_OPTION) 
            return false;
            
        String fileName = open_dialog.getSelectedFile().getName();
        
        SettingsImport sImport=new SettingsImport();
        Settings localCfg=sImport.importSettingsFile(fileName);               
        config=localCfg;
        StoreSettingsToGUI(localCfg);
        
        return true;
    }
   
    public void msgErr(String s)
    {
    	JOptionPane.showMessageDialog(this, s, "Input error", JOptionPane.ERROR_MESSAGE);
    }
    
    public boolean VerifySettings()
    {
    	int dummyInt=0;
    	float dummyFloat=0;
               
        try {	
    	    dummyInt=java.lang.Integer.parseInt(DurationTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Duration is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Duration is a bad number (Integer>0)");
            return false;
        }
        
        try {	
    	    dummyInt=java.lang.Integer.parseInt(WidthTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Width is a bad number (Integer>=1)");
            return false;
        }
        if (dummyInt<1)
        {
            msgErr("Width is a bad number (Integer>=1)");
            return false;
        }
        
        try {	
    	    dummyInt=java.lang.Integer.parseInt(HeightTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Height is a bad number (Integer>=1)");
            return false;
        }
        if (dummyInt<1)
        {
            msgErr("Height is a bad number (Integer>=1)");
            return false;
        }
                
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(IntensityTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Light intensity is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Light intensity is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyInt=java.lang.Integer.parseInt(SubstrateAmountTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Substrate amount is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Substrate amount is a bad number (Integer>0)");
            return false;
        }
    
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(SubstrateRenewTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Substrate renew rate is a bad number (1>Float>0)");
            return false;
        }
        if ((dummyFloat<=0)||(dummyFloat>=1))
        {
            msgErr("Substrate renew rate is a bad number (1>Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(Substrate4DeadAgentTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Substrate for a dead agent is a bad number (Float>=0)");
            return false;
        }
        if (dummyFloat<0)
        {
            msgErr("Substrate for a dead agent is a bad number (Float>=0)");
            return false;
        }
        
        if (PeriodicSubstrateCB.isSelected())
        try {	
    	    dummyInt=java.lang.Integer.parseInt(PeriodicSubstrateAmountTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Substrate for periodic substrate amount is a bad number (Integer>=0)");
            return false;
        }
        if (dummyInt<0)
        {
            msgErr("Substrate for a dead agent is a bad number (Integer>=0)");
            return false;
        }
        
        if (PeriodicSubstrateCB.isSelected())
        try {	
    	    dummyInt=java.lang.Integer.parseInt(PeriodicSubstrateStepsTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Number of steps for periodic substrate input is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Number of steps for periodic substrate input is a bad number (Integer>0)");
            return false;
        }
                            
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(PheroDecreaseTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Pheromone decrease rate is a bad number (1>Float>0)");
            return false;
        }
        if ((dummyFloat<=0)||(dummyFloat>=1))
        {
            msgErr("Pheromone decrease renew rate is a bad number (1>Float>0)");
            return false;
        }

	try {	
    	    dummyInt=java.lang.Integer.parseInt(InitialAlgaesTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Initial algaes is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Initial algaes is a bad number (Integer>0)");
            return false;
        }
    
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(InitialEnergyTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Initial energy is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Initial energy is a bad number (Float>0)");
            return false;
        }
    
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(AgentTransluencyTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Agent transluency is a bad number (1=>Float>=0)");
            return false;
        }
        if ((dummyFloat<0)||(dummyFloat>1.0f))
        {
            msgErr("Agent transluency is a bad number (1=>Float>=0)");
            return false;
        }

      	try {	
    	    dummyFloat=java.lang.Float.parseFloat(PheromoneRadiusTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Pheromone radius is a bad number (Float>=0)");
            return false;
        }
        if (dummyFloat<0)
        {
            msgErr("Pheromone radius is a bad number (Float>=0)");
            return false;
        }
 
    
    	try {	
    	    dummyInt=java.lang.Integer.parseInt(RandomSeedTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Random seed is a bad number (Integer>=0)");
            return false;
        }
        if (dummyInt<0)
        {
            msgErr("Random seed is a bad number (Integer>=0)");
            return false;
        }
    
    	try {	
    	    dummyInt=java.lang.Integer.parseInt(PheromoneFOVTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Pheromone FOV is a bad number (Integer>=0)");
            return false;
        }
        if (dummyInt<0)
        {
            msgErr("Pheromone FOV is a bad number (Integer>=0)");
            return false;
        }

	try {	
    	    dummyInt=java.lang.Integer.parseInt(PheromoneRangeTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Pheromone range is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Pheromone range is a bad number (Integer>0)");
            return false;
        }

	try {	
    	    dummyInt=java.lang.Integer.parseInt(SubstrateFOVTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Substrate FOV is a bad number (Integer>=0)");
            return false;
        }
        if (dummyInt<0)
        {
            msgErr("Substrate FOV is a bad number (Integer>=0)");
            return false;
        }

	try {	
    	    dummyInt=java.lang.Integer.parseInt(SubstrateRangeTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Substrate range is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Substrate range is a bad number (Integer>0)");
            return false;
        }

	try {	
    	    dummyInt=java.lang.Integer.parseInt(LightFOVTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Light FOV is a bad number (Integer>=0)");
            return false;
        }
        if (dummyInt<0)
        {
            msgErr("Light FOV is a bad number (Integer>=0)");
            return false;
        }

	try {	
    	    dummyInt=java.lang.Integer.parseInt(LightRangeTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Light range is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Light range is a bad number (Integer>0)");
            return false;
        }

	try {	
    	    dummyInt=java.lang.Integer.parseInt(BumperRangeTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Bumper range is a bad number (Integer>0)");
            return false;
        }
        if (dummyInt<=0)
        {
            msgErr("Bumper range is a bad number (Integer>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(EnergyMovementTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Energy consumption for movement is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Energy consumption for movement is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(EnergyStandStillTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Energy consumption for standstill is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Energy consumption for standstill is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(EnergyMitoseTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Energy consumption for mitosis is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Energy consumption for mitosis is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(EnergyMeioseTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Energy consumption for meiosis is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Energy consumption for meiosis is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(EnergyPOutputTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Energy consumption for pheromone output is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Energy consumption for pheromone output is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(EnergySubstrateTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Energy collecting for substrate is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Energy collecting for substrate is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(EnergyLightTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Energy collecting for light is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Energy collecting for light is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(MinEnergyMitoseTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Min. energylevel for mitose is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Min. energylevel for mitose is a bad number (Float>0)");
            return false;
        }
    
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(MinEnergyMeioseTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Min. energylevel for meiose is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Min. energylevel for meiose is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(MinEnergyPOutputTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Min. energylevel for pheromone output is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Min. energylevel for pheromone output is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(MaxSatPheromoneTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Max. saturation for pheromone is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Max. saturation for pheromone is a bad number (Float>0)");
            return false;
        }
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(MaxSatSubstrateTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Max. saturation for substrate is a bad number (Float>0)");
            return false;
        }
        if (dummyFloat<=0)
        {
            msgErr("Max. saturation for substrate is a bad number (Float>0)");
            return false;
        }

       	try {	
    	    dummyInt=java.lang.Integer.parseInt(NumberOfNeuronsTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Number of neurons is a bad number (Integer>=22)");
            return false;
        }
        if (dummyInt<22)
        {
            msgErr("Number of neurons is a bad number (Integer>=22)");
            return false;
        }

    	if (CubicSplineRB.isSelected())
    	{
       	    try {	
    	        dummyInt=java.lang.Integer.parseInt(NumberOfCSNodesTF.getText());
    	    } catch (NumberFormatException e)
            {
                msgErr("Number of CS nodes is a bad number (Integer>2)");
                return false;
            }
            if (dummyInt<=2)
            {
                msgErr("Number of CS nodes is a bad number (Integer>2)");
                return false;
            }
	}
	if (NPointCrossRB.isSelected())
	{
       	    try {	
    	        dummyInt=java.lang.Integer.parseInt(NPointCrossTF.getText());
    	    } catch (NumberFormatException e)
            {
                msgErr("Number of crossover points is a bad number (Integer>=1)");
                return false;
            }
            if (dummyInt<1)
            {
                msgErr("Number of crossover points is a bad number (Integer>=1)");
                return false;
            }
        }           
        
        try {	
    	    dummyFloat=java.lang.Float.parseFloat(AnnMutationRateTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("ANN Mutation rate is a bad number (1>=Float>=0)");
            return false;
        }
        if ((dummyFloat<0)||(dummyFloat>1))
        {
            msgErr("ANN Mutation rate is a bad number (1>=Float>=0)");
            return false;
        }
	try {	
    	    dummyFloat=java.lang.Float.parseFloat(CsMutationRateTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("CS Mutation rate is a bad number (1>=Float>=0)");
            return false;
        }
        if ((dummyFloat<0)||(dummyFloat>1))
        {
            msgErr("CS Mutation rate is a bad number (1>=Float>=0)");
            return false;
        }

        try {	
    	    dummyFloat=java.lang.Float.parseFloat(InitialANNBiasTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("Initial ANN bias is a bad number (1>=Float>=0)");
            return false;
        }
        if ((dummyFloat<0)||(dummyFloat>1))
        {
            msgErr("Initial ANN bias is a bad number (1>=Float>=0)");
            return false;
        }

        try {	
    	    dummyFloat=java.lang.Float.parseFloat(AnnCrossOverRateTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("ANN Crossover rate is a bad number (1>=Float>=0)");
            return false;
        }
        if ((dummyFloat<0)||(dummyFloat>1))
        {
            msgErr("ANN Crossover rate is a bad number (1>=Float>=0)");
            return false;
        }
	try {	
    	    dummyFloat=java.lang.Float.parseFloat(CsCrossOverRateTF.getText());
    	} catch (NumberFormatException e)
        {
            msgErr("CS Crossover rate is a bad number (1>=Float>=0)");
            return false;
        }
        if ((dummyFloat<0)||(dummyFloat>1))
        {
            msgErr("CS Crossover rate is a bad number (1>=Float>=0)");
            return false;
        }

    	return true;
    }
    
    public void setToolTips()
    {
    	DurationTF.setToolTipText("Integer>0");
	WidthTF.setToolTipText("Integer>=1");
	HeightTF.setToolTipText("Integer>=1");
	IntensityTF.setToolTipText("Float>0");
	SubstrateAmountTF.setToolTipText("Integer>0");
	SubstrateRenewTF.setToolTipText("0<Float<1");
	Substrate4DeadAgentTF.setToolTipText("Float>=0");
	PeriodicSubstrateAmountTF.setToolTipText("Integer>=0");
	PeriodicSubstrateStepsTF.setToolTipText("Integer>0");
	PheroDecreaseTF.setToolTipText("0<Float<1");
	InitialAlgaesTF.setToolTipText("Integer>0");
	InitialEnergyTF.setToolTipText("Float>0");
	AgentTransluencyTF.setToolTipText("0<=Float<=1");
	PheromoneRadiusTF.setToolTipText("Float>=0");
	
	RandomSeedTF.setToolTipText("Integer>=0");
	PheromoneFOVTF.setToolTipText("Integer>=0");
	PheromoneRangeTF.setToolTipText("Integer>0");
	SubstrateFOVTF.setToolTipText("Integer>=0");
	SubstrateRangeTF.setToolTipText("Integer>0");
	LightFOVTF.setToolTipText("Integer>=0");
	LightRangeTF.setToolTipText("Integer>0");
	BumperRangeTF.setToolTipText("Integer>0");
	
	EnergyMovementTF.setToolTipText("Float>0");
	EnergyStandStillTF.setToolTipText("Float>0");
	EnergyMitoseTF.setToolTipText("Float>0");
	EnergyMeioseTF.setToolTipText("Float>0");
	EnergyPOutputTF.setToolTipText("Float>0");
	EnergySubstrateTF.setToolTipText("Float>0");
	EnergyLightTF.setToolTipText("Float>0");
	MinEnergyMitoseTF.setToolTipText("Float>0");
	MinEnergyMeioseTF.setToolTipText("Float>0");
	MinEnergyPOutputTF.setToolTipText("Float>0");
	MaxSatPheromoneTF.setToolTipText("Float>0");
	MaxSatSubstrateTF.setToolTipText("Float>0");
	
	NumberOfNeuronsTF.setToolTipText("Integer>=22");
	NumberOfCSNodesTF.setToolTipText("Integer>2");
	NPointCrossTF.setToolTipText("Integer>=1");
	AnnMutationRateTF.setToolTipText("0<=Float<=1");
	CsMutationRateTF.setToolTipText("0<=Float<=1");
	InitialANNBiasTF.setToolTipText("0<=Float<=1");
	AnnCrossOverRateTF.setToolTipText("0<=Float<=1");
	CsCrossOverRateTF.setToolTipText("0<=Float<=1");
    }
    
    public Settings getSettingsVar()
    {
    	return config;
    }

    public void actionPerformed(ActionEvent e)
        {
	    Object src=e.getSource();
	    if (src==SaveBtn) 
	    {
		if (!VerifySettings())
		   return;
		System.out.println("Saving file...");
		ExportSettingsFile();		
	    }
	    if (src==LoadBtn)
	    {
	 	System.out.println("Loading file...");
		if (DialogImportSettingsFile())
		    config=StoreSettingsToVar();
		System.out.println("Loading file finished...");
	    }
	    if (src==QuitBtn)
	    {
	    	//Custom button text
	        Object[] options = {"Yes","No",};
                int result = JOptionPane.showOptionDialog(this,
                        "Do you really like to quit ALGAE ?",
                        "Confirmation",
                        JOptionPane.YES_NO_OPTION,
                        JOptionPane.QUESTION_MESSAGE,
                        null,
                        options,
                        options[1]);
		if (result==JOptionPane.YES_OPTION)
		    System.exit(0);
	    }
	    if (src==OKBtn)
	    {
		if (!VerifySettings())
		   return;
		config=StoreSettingsToVar();
		    		
    		if ((window!=null)&&(window.isDisplayable()==false))
    		{
    		    window=null;
    		    System.out.println("Happening: window undisplayable - recreating it");
    		}
    		
    		if (window==null)
    		    window = new MainGUI(config);
    		else
    		{
    		    window.dispose();
    		    window = new MainGUI(config);    		    
    		}
						
		window.setTitle("ALGAE Simulation - "+(String)PresetsCombo.getSelectedItem());
		window.setResizable(true);
		window.setSize(800,600);
		window.setVisible(true);
			
		// this is a kind of hack
		// done, because the state of the world
		// should be drawn, when window is created
		WorldState wsLocal=window.contr.getState();
	    	window.paintAll(wsLocal,false);
			
	    }
	    if (src==PresetsCombo)
	    {
		System.out.println("COMBO DONE");
	    	if ((PresetsCombo.getSelectedItem()!="No presets")&&
	    	    (PresetsCombo.getSelectedItem()!="-----"))	    	
	    	{
	    	    System.out.println("Huhu - good selection");
	    	    SettingsImport sImport=new SettingsImport();
        	    Settings localCfg=sImport.importSettingsFile((String)PresetsCombo.getSelectedItem());               
        	    config=localCfg;
                    StoreSettingsToGUI(localCfg);
	    	}
	    	else
	    	{
	    	    System.out.println("No, \"No presets\" is not a good choice");	
	    	}
	    }
	    if (src==LightEnabledCB)
	    {
	    	boolean tmp=LightEnabledCB.isSelected();
		AllTheTimeRB.setEnabled(tmp);
		FunctionRB.setEnabled(tmp);
		LightDistFuncCombo.setEnabled(tmp);
		IntensityTF.setEnabled(tmp);
		
		if (!tmp)
		{
		   LightCycleFuncCombo.setEnabled(false); 	
		}
		else
		{
		   if (AllTheTimeRB.isSelected())
		       LightCycleFuncCombo.setEnabled(false); 	
		   else
		       LightCycleFuncCombo.setEnabled(true); 	
		}
	    }
	    if (src==AllTheTimeRB)
	    {
	    	LightCycleFuncCombo.setEnabled(false); 	
	    }
	    if (src==FunctionRB)
	    {
	    	LightCycleFuncCombo.setEnabled(true); 	
	    }
	    if (src==PeriodicSubstrateCB)
	    {
	    	boolean state=PeriodicSubstrateCB.isSelected();
			
		PeriodicSubstrateAmountTF.setEnabled(state);
		PeriodicSubstrateStepsTF.setEnabled(state);  	
	    	
	    	SubstrateDistFuncCombo.setEnabled(!state);
	    }
	    if (src==OnePointCrossRB)
	    {
	    	NPointCrossTF.setEnabled(false);
	    }
	    if (src==TwoPointCrossRB)
	    {
	    	NPointCrossTF.setEnabled(false);
	    }
	    if (src==NPointCrossRB)
	    {
	    	NPointCrossTF.setEnabled(true);
	    }
	    if (src==CubicSplineRB)
	    {
		TransferFuncCombo.setEnabled(false);
		NumberOfCSNodesTF.setEnabled(true);
	    }
	    if (src==TransferFuncRB)
	    {
		TransferFuncCombo.setEnabled(true);
		NumberOfCSNodesTF.setEnabled(false);
	    }
	
    }
	           
    public boolean isPreset(String s)
    {
    	String xml_extension="asf";
    	int i = s.lastIndexOf('.');
        if (i > 0 &&  i < s.length() - 1)
        {
            String extension = s.substring(i+1).toLowerCase();
            if (xml_extension.equals(extension))
                return true;
            else
                return false;
        }
        return false;
    }
         
    public void AddASFFilesToCombo()
    {
    	boolean found=false;
    	
    	File filePath = new File(".");
    	File[] files=filePath.listFiles();
    	if (files==null)
	{
	    System.out.println("No appropriate files (*.asf) found...");
	    return;
	}
	for (int k=0; k<files.length; k++) 
        {
            if (isPreset(files[k].getName()))
            {
               	PresetsCombo.addItem(files[k].getName());
               	found=true;
            }
        }
        
        if (!found)
        {
            String []preNone={"No presets"};
            PresetsCombo = new JComboBox(preNone);
        }
        
        System.out.println("Several asf-files found (at least one)");
    }
   
    public SettingsDialog(){
	addWindowListener(new WindowAdapter() 
        {
	    public void windowClosing(WindowEvent e) 
	    {
		 System.exit(0);
            }
        });
	
	/*
	try {
	UIManager.setLookAndFeel(
        "com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
        //"com.sun.java.swing.plaf.motif.MotifLookAndFeel");
        //"javax.swing.plaf.metal.MetalLookAndFeel");  	
	} catch (Exception e) { System.out.println("EXCEPTION: UIManager.setLookAndFeel");}
	*/
		        
	contentPane=getContentPane();
	contentPane.setLayout(gridbag);

	TabbedPane.addChangeListener(new TabbedListener());
	TabbedPane.addTab("Simulation",SimulationPanel);
	TabbedPane.addTab("Light",LightPanel);
	TabbedPane.addTab("Substrate",SubstratePanel);
	TabbedPane.addTab("Algaes",AlgaesPanel);
	TabbedPane.addTab("Sensors",SensorsPanel); 
	TabbedPane.addTab("Actions",ActionPanel);
	TabbedPane.addTab("ANNs",ANNPanel);
	TabbedPane.addTab("Evolution",EvolutionPanel);
		
	//TabbedPane.addMouseListener(this);

	TopPanel.setLayout(new GridLayout(1,1));
	TopPanel.add(TabbedPane);

	BottomPanel.setLayout(new GridLayout(1,5));

	LoadBtn.addActionListener(this); 
	SaveBtn.addActionListener(this);
	OKBtn.addActionListener(this);
	QuitBtn.addActionListener(this);
	BottomPanel.add(OKBtn);
	BottomPanel.add(QuitBtn);
        BottomPanel.add(LoadBtn);
	BottomPanel.add(SaveBtn);
	
	PresetsCombo.addActionListener(this);
	BottomPanel.add(PresetsCombo);

	// search for all files in current directory
        // matching the "*.asf" file extension and store
	// them into a combo box
	AddASFFilesToCombo();

	c.gridx = 0;
        c.gridy = 0;
        c.gridwidth=23;
        c.gridheight=12;
        c.weightx=1;
        c.weighty=1;
        c.insets=new Insets(2,2,2,2);
        c.fill = GridBagConstraints.BOTH;
        gridbag.setConstraints(TopPanel, c);
        contentPane.add(TopPanel);

	c.gridx = 0;
        c.gridy = 12;
        c.gridwidth=23;
        c.gridheight=2;
        c.weightx=1;
        c.weighty=0;
        c.insets=new Insets(2,2,2,2);
        c.fill = GridBagConstraints.NONE;
        gridbag.setConstraints(BottomPanel, c);
        contentPane.add(BottomPanel);	

	MakeSimulationPanel();
	MakeAlgaesPanel();
 	MakeSensorsPanel();	
       	MakeActionsPanel();      	
    	MakeANNPanel();
    	MakeEvolutionPanel();
	MakeSubstratePanel();
	MakeLightPanel();
	
	setToolTips();
    }
}
