package algae.simulation;

public final class Settings {
    
    // simulation settings
    public int duration; // duration of simulation in steps
    public int width;    // width of aquarium
    public int height;   // height of aquarium

    public int randSeed; // random seed
    public float pheromone_dec_rate;   // decrease rate of pheromone
 	
    // light settings
    public int light_enabled; // disabled (0), always (1), function (2)
    public float light_intensity; // intensity of light
    
    public int light_function; // light function 
    public int light_cycle_function; // not implmented yet
    // (sin, rect, chainsaw, zigzag)
   
    // substrate settings 
    public int substrate_amount; // amount of substrate at the beginning 
    public float substrate_renew_rate; // renew rate of substrate
    public float substrate_for_dead_agent;  // substrate generated out of a dead agent
    public int substrate_periodic_amount; // amount added during a period
    public int substrate_periodic_steps;  // steps for one period
    public int substrate_function; // function used for substrate distribution
    public int periodic_substrate; // is periodic substrate refresh enabled ?
    
    // algaes settings
    public int initial_algaes; // how many algaes arte there at the beginning
    public float initial_energy; // how much energy (0.0-1.0) at the beginning
    public float agent_transluency; 
    public float pheromone_radius;

    // senors settings
    public int pheromone_fov; // FOV of pheromone sensor
    public int pheromone_range; // range of sight of pheromone sensor
    public int substrate_fov; // FOV of substrate sensor
    public int substrate_range; // range of sight of substrate sensor
    public int light_fov; // FOV of light sensor
    public int light_range; // range of sight of light sensor
    public int bumper_range; // range of sight of bumper sensor

    // actions settings
    // -- using energy
    public float energy_movement; // energy needed for movement
    public float energy_mitose; // energy needed for mitose
    public float energy_meiose; // energy needed for meiose
    public float energy_pheromone_output; // energy needed for pheromone output
    public float energy_standstill; //energy needed for standstill

    public float min_energy_mitose;
    public float min_energy_meiose;
    public float min_energy_pheromone_output;
    
    public float max_pheromone_saturation;
    public float max_substrate_saturation;

    // -- collecting energy
    public float energy_substrate; // energy the algae gets for substrate
    public float energy_light; // energy the algae gets for light
    
    // ann settings
    public int number_of_neurons; // how many neurons are used within the ANNs
    public int spline_node_count; // how many nodes are used for the cubic splines
    public int ann_transfer_func; // transfer function to use
    public float initial_ann_bias; 
    
    // evolution settings
    public int crossover_type;	// 1-point, 2-point or n-point
    public float ann_mutation_rate;
    public float ann_crossover_rate;
    public float cs_mutation_rate;
    public float cs_crossover_rate;
    
}
