
/**
 * WorldState.java
 *
 *
 * Created: Sat Jul 15 14:49:04 2000
 *
 * @author 
 * @version
 */

package algae.simulation;

import algae.simulation.view.*;
import algae.simulation.view.ViewSubstrate;
import algae.simulation.view.ViewPheromone;

public class WorldState  {
    
    public int steps;
    public int stepsToRun;
    public int dimx;
    public int dimy;
    
    public ViewAgent aList[];
    public ViewSubstrate sList[];
    public float substrateAmount;
    public ViewPheromone[] pList;
    public ViewLight lList[];
    public float lightIntensity;
    
    public WorldState(WC wc) {
	steps=wc.stepsRunning;
	stepsToRun=wc.stepsToRun;
	dimx=wc.cfg.width;
	dimy=wc.cfg.height;
	
	aList=wc.agents.getList();
	
	if (aList==null)
	   System.out.println("aList==null");
	
	sList=wc.substrate.getList();
	/*
	if (sList==null)
        {
	   System.out.println("sList==null");
	   substrateAmount=0.0f;
	}
	*/
	substrateAmount=(float)wc.substrate.totalAmount;
	   
	pList=wc.pheromone.getList();
	if (pList==null)
	   System.out.println("pList==null");
	   
	lList=wc.light.getList();
	if (lList==null)
	   System.out.println("lList==null");
	   
	lightIntensity=(float)wc.light.intensity;
    }
    
} // WorldState
