
/**
 * AgentWorld.java
 *
 *
 * Created: Tue Jul 04 12:19:04 2000
 *
 * @author 
 * @version
 */
package algae.simulation.worlds;

import algae.simulation.agents.Agent;
import algae.simulation.Settings;
import algae.simulation.view.ViewAgent;
import algae.simulation.SinCosLut;
import java.util.Random;
import java.lang.Object;
import java.util.*;

public class AgentWorld extends algae.simulation.worlds.World {
   
    public Vector agents=new Vector(100,1);
    public int agentCount;
    public int newAgentCount;
    public int MAX_AGENTS;

    public SubstrateWorld sw;
    public LightWorld lw;
    public PheromoneWorld pw;

    Settings cfg;
    Random rand;
  
    public int stepDeadCount = 0;
    public int stepMeiosisCount = 0;
    public int stepMitosisCount = 0;
    public int stepSubstrateUsed = 0;
    public int stepSubstrateNew = 0;
    public int stepPheromoneUsed = 0;
    public int stepPheromoneNew = 0;
    public int stepLightUsed = 0;

    public int currentAgentID=0;

    public SinCosLut lut = new SinCosLut();

    public int currentStep = -1;
    
    class Element extends World.Element
    {
	final double NOTHING = 0.0; 
	
	// Constructors
	public Element()
	    {
		this.amount = NOTHING;

	    }
	
	// Operations
	
	public boolean exists()
	    {
		return (this.amount > 0);
	    }
	
	public boolean add(int steps) 
	    {
	    	return true;
	    } //deplete
	    
        public boolean put(float amount) 
	{
		return true;
	}
	
	public boolean remove(int steps)
	{
		return true;
	}
	
	boolean update()
	    {
		return true;
	    } // update
	
    }// end class Element

    public void initAgents()
    {
   	Agent tmp;
	rand=new Random(cfg.randSeed);
	System.out.println("inserting and initializing "+agentCount+" agents... - this may take a while..."); 
	for (int i=0; i<agentCount; i++)
	{
	     System.out.print(i+" ");
	     int ix=Math.abs(rand.nextInt()%cfg.width);
	     int iy=Math.abs(rand.nextInt()%cfg.height);
	     
	     currentAgentID++;
	     tmp=new Agent(ix,iy,cfg,rand,this,sw,pw,lw,currentAgentID);     
	     
	     while (this.world[tmp.y][tmp.x].amount!=0)
	     {
	     	tmp.x=Math.abs(rand.nextInt()%cfg.width);
	     	tmp.y=Math.abs(rand.nextInt()%cfg.height);
	     }
	     
	     this.world[tmp.y][tmp.x].amount=(double)(i+1);
	     agents.add(tmp);
	}
	System.out.println("initial algaes set and initialized");
    }

    public AgentWorld(Settings set, SubstrateWorld s, 
                      PheromoneWorld p, LightWorld l) {
	super(set.height,set.width);
	MAX_AGENTS = set.height*set.width;
	cfg=set;
	agentCount=cfg.initial_algaes;

	pw=p;
	sw=s;
	lw=l;
	
	for (int i=0; i<cfg.width; i++)
	    for (int j=0; j<cfg.height; j++)
	        this.world[j][i]=new Element();

	// the world can't hold more algaes, than fit into the aqua
	if (agentCount>MAX_AGENTS)
	   agentCount=MAX_AGENTS;

	initAgents();
    }
        
    int findNeighbour(Agent a, boolean empty)
    {
    	int nOf=a.agentID;
    	if (empty)
    	{
    	    // search for an empty field to place a new agent into it
    	    
    	    // search for an algae on the left side
    	    if (a.x-1>=0)
    	       if (this.world[a.y][a.x-1].amount==0.0f)
    	       {
    	   	   return 1; // indicate free place : left
    	       }  
    	    // search for an algae on the right side
    	    if (a.x+1<cfg.width)
    	       if (this.world[a.y][a.x+1].amount==0.0f)
    	       {
    	   	   return 2; // indicate free place : right
    	       }  
    	    // search for an algae above
    	    if (a.y-1>=0)
    	       if (this.world[a.y-1][a.x].amount==0.0f)
    	       {
    	   	   return 3; // indicate free place : above
    	       }  
    	    // search for an algae above
    	    if (a.y+1<cfg.height)
    	       if (this.world[a.y+1][a.x].amount==0.0f)    
    	       {
    	   	   return 4; // indicate free place : below
    	       }
    	    // left upper 
    	    if ((a.x-1>=0)&&(a.y-1>=0))
    	       if (this.world[a.y-1][a.x-1].amount==0.0f)
    	       {
    	   	   return 5; // indicate : left upper
    	       }  
    	    // right upper
    	    if ((a.x+1<cfg.width)&&(a.y-1>=0))
    	       if (this.world[a.y-1][a.x+1].amount==0.0f)
    	       {
    	   	   return 6; // indicate: right upper
    	       }  
    	    // left lower
    	    if ((a.x-1>=0)&&(a.y+1<cfg.height))
    	       if (this.world[a.y+1][a.x-1].amount==0.0f)
    	       {
    	   	   return 7; // left lower
    	       }  
    	    // right lower
    	    if ((a.x+1<cfg.width)&&(a.y+1<cfg.height))
    	       if (this.world[a.y+1][a.x+1].amount==0.0f)
    	       {
    	   	   return 8; // right lower
    	       }
	}
	else
	{
    	    // search for a non-empty field to find a potential
    	    // agent for sexual reproduction
    	    // search for an algae on the left side
    	    //System.out.print(".");
    	    if (a.x-1>=0)
    	       if ((this.world[a.y][a.x-1].amount>0.0f)&&
    	           (this.world[a.y][a.x-1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y][a.x-1].amount);
    	       }  
    	    // search for an algae on the right side
    	    //System.out.print(".");
    	    if (a.x+1<cfg.width)
    	       if ((this.world[a.y][a.x+1].amount>0.0f)&&
    	           (this.world[a.y][a.x+1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y][a.x+1].amount);
    	       }  
    	    // search for an algae above
    	    //System.out.print(".");
    	    if (a.y-1>=0)
    	       if ((this.world[a.y-1][a.x].amount>0.0f)&&
    	           (this.world[a.y-1][a.x].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y-1][a.x].amount);
    	       }  
    	    // search for an algae above
    	    //System.out.print(".");
    	    if (a.y+1<cfg.height)
    	       if ((this.world[a.y+1][a.x].amount>0.0f)&&
    	           (this.world[a.y+1][a.x].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y+1][a.x].amount);
    	       }
    	    // left upper 
    	    //System.out.print(".");
    	    if ((a.x-1>=0)&&(a.y-1>=0))
    	       if ((this.world[a.y-1][a.x-1].amount>0.0f)&&
    	           (this.world[a.y-1][a.x-1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y-1][a.x-1].amount);
    	       }  
    	    // right upper
    	    //System.out.print(".");
    	    if ((a.x+1<cfg.width)&&(a.y-1>=0))
    	       if ((this.world[a.y-1][a.x+1].amount>0.0f)&&
    	           (this.world[a.y-1][a.x+1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y-1][a.x+1].amount);
    	       }  
    	    // left lower
    	    //System.out.print(".");
    	    if ((a.x-1>=0)&&(a.y+1<cfg.height))
    	       if ((this.world[a.y+1][a.x-1].amount>0.0f)&&
    	           (this.world[a.y+1][a.x-1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y+1][a.x-1].amount);
    	       }  
    	    // right lower
    	    //System.out.print(".");
    	    if ((a.x+1<cfg.width)&&(a.y+1<cfg.height))
    	       if ((this.world[a.y+1][a.x+1].amount>0.0f)&&
    	           (this.world[a.y+1][a.x+1].amount!=nOf))
    	       {
    	   	   return (int)(world[a.y+1][a.x+1].amount);
    	       }
    	}  
   	return -1;
    }
    
    public int move(Agent tmp, int sel)
    {
    	int ox=tmp.x;
    	int oy=tmp.y;
    	boolean moved=false;
    	// and decide what to do (movement)
	     	switch (sel)
	     	{
	     	     // stand still
	     	     case 0: // do nothing
	     	     	     tmp.energy_level-=cfg.energy_standstill;
	     	             break;
	     	             
	     	     // go right
	     	     case 1: if (tmp.x<cfg.width-1) 
	     	     		if (this.world[tmp.y][tmp.x+1].amount==0)
	     	     		{
	     	     		    tmp.x++;
	     	     		    moved=true;
	     	     		}
	     	     		    
	     	     	     tmp.dir=1;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     		     
	     	     // go down
	     	     case 2: if (tmp.y<cfg.height-1) 
	     	     		if (this.world[tmp.y+1][tmp.x].amount==0)
	     	     		{
	     	     		    tmp.y++;
	     	     		    moved=true;
	     	     		}

	     		     tmp.dir=2;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     		     
	     	     // go left
	     	     case 3: if (tmp.x>0) 
	     	     		if (this.world[tmp.y][tmp.x-1].amount==0)
	     	     		{
	     	     		    tmp.x--;
	     	     		    moved=true;
	     	     		}

	     		     tmp.dir=3;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     	     
	     	     // go up
	     	     case 4: if (tmp.y>0) 
	     	             {
	     	     		if (this.world[tmp.y-1][tmp.x].amount==0)
	     	     		{
	     	     		    tmp.y--;
	     	     		    moved=true;
	     	     		}
	     	             }

	     		     tmp.dir=4;
	     		     tmp.energy_level-=cfg.energy_movement;
	     		     break;
	     	}		
	        
	        if (tmp.energy_level<=0.0f)
	        {
	           tmp.dead=true;
	           this.world[oy][ox].amount=0;
	 	   this.world[tmp.y][tmp.x].amount=0;
	 	   //lw.update(ox,oy);
	           return -1; // indicate that the agent died
	        }  
	 
	 if (moved)
	    this.world[oy][ox].amount=0;
	 //lw.update(ox,oy,tmp.x,tmp.y);
	 return 0;	        
    }
    
    public int doPheromoneOutput(Agent tmp)
    {
	 pw.set(tmp.x,tmp.y); 
	 tmp.energy_level-=cfg.energy_pheromone_output;
	 
	 if (tmp.energy_level<=0.0f)
	 {
	     tmp.dead=true;
	     this.world[tmp.y][tmp.x].amount=0;
	     return -1; // agent died
	 }  
	 return 0;	        
    }
    
    public Agent getAgentByID(int ID)
    {
    	for (int z=0; z<newAgentCount; z++)
    	{
    	    Agent tmp=(Agent)agents.elementAt(z);
    	    if (tmp.agentID==ID)
    	       return tmp;
    	}
    	return null;
    }
    
    public int findFreeAgent()
    {
    	for (int z=0; z<newAgentCount; z++)
    	{
    	    Agent tmp=(Agent)agents.elementAt(z);
    	    if (tmp.dead|tmp.died)
    	    {
    	    	System.out.println("IMPORTANT: overwriting agentID "+tmp.agentID);
    	    	return z;
    	    }
    	}
    	return -1;
    }
    
    public int getAgentIndex(Agent a)
    {
    	for (int z=0; z<newAgentCount; z++)
    	{
    	    Agent tmp=(Agent)agents.elementAt(z);
    	    if (tmp.agentID==a.agentID)
    	    {
    	    	return z;
    	    }
    	}
    	return -1;
    }

    public int getAgentIndexByID(int ID)
    {
    	for (int z=0; z<newAgentCount; z++)
    	{
    	    Agent tmp=(Agent)agents.elementAt(z);
    	    if (tmp.agentID==ID)
    	    {
		System.out.println("AGENT with ID "+ID+" has index "+z);
    	    	return z;
    	    }
    	}
    	return -1;
    }
    
    // move, update (position, consume substrate) and populate the agents 
    public void step(int steps)
    {
    	currentStep=steps;
    	boolean newAgentCreated=false;
    	
	stepDeadCount = 0;
        stepMeiosisCount = 0;
        stepMitosisCount = 0;
        stepSubstrateUsed = 0;
        stepSubstrateNew = 0;
    	stepPheromoneUsed = 0;
    	stepPheromoneNew = 0;
    	stepLightUsed = 0;
	
	lw.used=0;
	lw.renew=0;
	
	sw.used=0;
	sw.renew=0;
	
	pw.used=0;
	pw.renew=0;
        	
    	Agent tmp;
    	newAgentCount=agentCount;
                        
	System.out.println("Step #"+steps);
	for (int z=0; z<agentCount; z++)
	{
    	    // get a reference to actual agent
	    tmp=(Agent)agents.elementAt(z);
	    
	    if (tmp==null) continue; // should never happen
	    
	    tmp.born=false;
	    	    
	    // mark the agent as "dead"
	    // this isn't done in the step the agent died, because
	    // we want to give the statistic-writer a chance to stream out the agent
	    if (tmp.died)
	    {
	    	tmp.died=false;
	    	tmp.dead=true;
	    }
	    	    
	    // process alive agents only
	    if (tmp.isAlive())
	    {
	    	tmp.lifeTime++;
	    	// reset several flags used for statistics
	    	tmp.madeMeiosis=false;
	    	tmp.madeMitosis=false;
	    	tmp.usedSubstrate=false;
	    	tmp.usedLight=false;
	    	tmp.died=false;
	    	tmp.dead=false;
	    	tmp.born=false;
	    	
	    	// process neural network
	     	int res=tmp.calcStep();
		
	     	// move the agent according to the ann-output
	     	if (move(tmp,res)==-1)
	     	{
	     	   System.out.println("agent #"+tmp.agentID+" died - movement");
	     	   stepDeadCount++;
	     	   tmp.died=true;
		   sw.world[tmp.y][tmp.x].amount+=cfg.substrate_for_dead_agent;	     	   
		   continue;
	        }
	        else
	        {
	           this.world[tmp.y][tmp.x].amount=tmp.agentID;
	        }
	     	
	        // throw out some pheromone
	        if (tmp.energy_level>=cfg.min_energy_pheromone_output)
	           if (doPheromoneOutput(tmp)==-1)
	           {   
	           	System.out.println("agent #"+tmp.agentID+" died - pheromoneout");
	           	stepDeadCount++;
	           	tmp.died=true;
	          	sw.world[tmp.y][tmp.x].amount+=cfg.substrate_for_dead_agent;	     	   
	         	this.world[tmp.y][tmp.x].amount=0;

	           	//lw.update(tmp.x,tmp.y);
	           	continue;
	           }
          	        	        
	        // look out for substrate at an agents' position
	        if (tmp.phenoType.metabolic[1]==1)
	        if (sw.world[tmp.y][tmp.x].remove(0))
	        {
	            tmp.energy_level+=cfg.energy_substrate;
	            stepSubstrateUsed++;	            
	            tmp.usedSubstrate=true;
	            tmp.gUsedSubstrate++;
	        }
	        
	        // consume some light
	        if (tmp.phenoType.metabolic[0]==1)
	        if (lw.consume(tmp.x,tmp.y)>0)
	        {
	            tmp.energy_level+=cfg.energy_light*lw.consume(tmp.x,tmp.y);
	            stepLightUsed++;
	            tmp.usedLight=true;
	            tmp.gUsedLight++;
	        }	        
           
	        // process population (mitosis,meiosis)     
	             
	        // first of all find a partner
	        int nb=findNeighbour(tmp,false);
	        
	        // partner found and enough energy for meiosis
	        if ((tmp.energy_level>=cfg.min_energy_meiose)&&(nb!=-1))
	        {
		    System.out.println("World.Step()Neighbour - (ID)nb="+nb+"   tmp.agentID="+tmp.agentID); 
	            Agent tmpAgent=getAgentByID(nb);
	            
	            if (tmpAgent==null)
	            {
	            	System.out.println("World.Step() - tmpAgent==NULL");		
	            }
	            	
	            currentAgentID++;
	            Agent newAgent=null;
	            int free=findFreeAgent();
	            if (free==-1)
	            {
	            	newAgent=new Agent(tmp,tmpAgent,cfg,rand,currentAgentID);
	            	newAgentCount++;
	            	newAgentCreated=true;
			System.out.println("AGENTWORLD.step: Created new agent");
	            }
	            else
	            {
	            	//TODO: new -> overwrites old (uses not more memory)????
	            	newAgent=new Agent(tmp,tmpAgent,cfg,rand,currentAgentID);
	            	newAgentCreated=false;
	            	agents.setElementAt((Object)newAgent,free);
			System.out.println("AGENTWORLD.step: old agent overwritten oldIdx="+free);
	            }
	            stepMeiosisCount++;
		    
		    tmp.gMeiosisCount++;
		    tmpAgent.gMeiosisCount++;
		    	
	            //newAgentCount++;
	            newAgent.born=true;
	            if (newAgentCreated)
	            	agents.add(newAgent); 
	            
	            tmp.addChild(currentAgentID);
	            tmpAgent.addChild(currentAgentID);
	            newAgent.setParents(tmp.agentID,nb);
	            newAgent.x=tmp.x;
	            newAgent.y=tmp.y;
	            
	            tmp.madeMeiosis=true;
	            tmpAgent.madeMeiosis=true;
	            	            
	            newAgent.madeMeiosis=false;
	    	    newAgent.madeMitosis=false;
	    	    newAgent.usedSubstrate=false;
	    	    newAgent.usedLight=false;
	    	    newAgent.died=false;
	    	    newAgent.dead=false;
	    	    newAgent.born=true;
	    	    newAgent.birthStep=steps;
	    		            
	            // test if tmpAgent died during meiosis
	            if (tmpAgent.energy_level<=0.0f)
	            {
	            	System.out.println("agentID "+nb+" died during MEIOSIS");
	            	this.world[tmpAgent.y][tmpAgent.x].amount=0;
	            	//lw.update(tmpAgent.x,tmpAgent.y);
	            	stepDeadCount++;
	            	tmpAgent.died=true;
	            	sw.world[tmpAgent.y][tmpAgent.x].amount+=cfg.substrate_for_dead_agent;	     	   
	            }
	        
	            int freeDir=findNeighbour(tmp,true);
	            
	            if (freeDir!=-1)
	            {
	            	switch (freeDir) {
	                   case 1: newAgent.x=tmp.x-1;
	                   	   newAgent.y=tmp.y;
	                   	   break;
	                   case 2: newAgent.x=tmp.x+1;
	                   	   newAgent.y=tmp.y;
	                   	   break;
	                   case 3: newAgent.x=tmp.x;
	                   	   newAgent.y=tmp.y-1;
	                   	   break;
	                   case 4: newAgent.x=tmp.x;
	                   	   newAgent.y=tmp.y+1;
	                   	   break;
	                   case 5: newAgent.x=tmp.x-1;
	                   	   newAgent.y=tmp.y-1;
	                   	   break;
	                   case 6: newAgent.x=tmp.x+1;
	                   	   newAgent.y=tmp.y-1;
	                   	   break;
	                   case 7: newAgent.x=tmp.x-1;
	                   	   newAgent.y=tmp.y+1;
	                   	   break;
	                   case 8: newAgent.x=tmp.x+1;
	                   	   newAgent.y=tmp.y+1;
	                   	   break;
	                   }	          	
	                   if (this.world[newAgent.y][newAgent.x].amount==0.0f)
	                   {
	                       this.world[newAgent.y][newAgent.x].amount=newAgent.agentID;
	                       //lw.update(newAgent.x,newAgent.y);
	                   }
	                   else
	                       System.out.println("Positioning error [MEIOSIS 1] - should really never happen");
	            }
	            else
	            if (tmpAgent.died==true)
	            {
	            	newAgent.x=tmpAgent.x;
	            	newAgent.y=tmpAgent.y;

			System.out.println("MEIOSIS: newAgent X/Y: "+newAgent.x+"/"+newAgent.y);	          	
	                System.out.println("MEIOSIS: newAgent Value in aWorld = "+this.world[newAgent.y][newAgent.x].amount);	          	
	                        
	                if (this.world[newAgent.y][newAgent.x].amount==0.0f)
	                {
	                    this.world[newAgent.y][newAgent.x].amount=newAgent.agentID;
	                    //lw.update(newAgent.x,newAgent.y);
	                }
	                else
	                    System.out.println("Positioning error [MEIOSIS 2] - should really never happen");
	            }
	            else
	            {
	            	freeDir=findNeighbour(tmpAgent,true);
	            
	                if (freeDir!=-1)
	            	{
	            	     switch (freeDir) {
	                   	case 1: newAgent.x=tmpAgent.x-1;
	                   	   	newAgent.y=tmpAgent.y;
	                   	   	break;
	                   	case 2: newAgent.x=tmpAgent.x+1;
	                   	   	newAgent.y=tmpAgent.y;
	                   	   	break;
	                   	case 3: newAgent.x=tmpAgent.x;
	                   	   	newAgent.y=tmpAgent.y-1;
	                   	   	break;
	                   	case 4: newAgent.x=tmpAgent.x;
	                   	   	newAgent.y=tmpAgent.y+1;
	                   	   	break;
	                   	case 5: newAgent.x=tmpAgent.x-1;
	                   	   	newAgent.y=tmpAgent.y-1;
	                   	   	break;
	                   	case 6: newAgent.x=tmpAgent.x+1;
	                   	   	newAgent.y=tmpAgent.y-1;
	                   	   	break;
	                   	case 7: newAgent.x=tmpAgent.x-1;
	                   	   	newAgent.y=tmpAgent.y+1;
	                   	   	break;
	                   	case 8: newAgent.x=tmpAgent.x+1;
	                   	   	newAgent.y=tmpAgent.y+1;
	                   	   	break;
	                   	}	          	
	                   	
	                   	System.out.println("MEIOSIS: newAgent X/Y: "+newAgent.x+"/"+newAgent.y);	          	
	                        System.out.println("MEIOSIS: newAgent Value in aWorld = "+this.world[newAgent.y][newAgent.x].amount);	          	
	                        	                   	
	                        if (this.world[newAgent.y][newAgent.x].amount==0.0f)
	                        {
	                            this.world[newAgent.y][newAgent.x].amount=newAgent.agentID;
	                            //lw.update(newAgent.x,newAgent.y);
	                        }
	                        else
	                            System.out.println("Positioning error [MEIOSIS 3] - should really never happen");
	            	}
	            	else
	            	{
	            	    // hmm, there is no free place around
	            	    // let the new agent die
	            	    System.out.println("MEIOSIS: new agent died because of no placement choice");
	            	    stepDeadCount++;
	            	    newAgent.died=true;
	            	    this.world[newAgent.y][newAgent.x].amount=0;

	            	    sw.world[newAgent.y][newAgent.x].amount+=cfg.substrate_for_dead_agent;	     	   
	            	}
	            }

		    if (tmp.energy_level<=0.0f)
		    {
		    	System.out.println("agentID "+tmp.agentID+" died - movement");
	     	    	stepDeadCount++;
	     	    	tmp.died=true;
		    	sw.world[tmp.y][tmp.x].amount+=cfg.substrate_for_dead_agent;	     	   
		    	this.world[tmp.y][tmp.x].amount=0;
	            	continue;
	            }

		    // test if agent is crippled
		    if (newAgent.genoType.isCrippled())
		    {
		    	System.out.println("agentID "+newAgent.agentID+" died - crippled");
	     	    	newAgent.died=true;	    	
		    	stepDeadCount++;
		    	this.world[newAgent.y][newAgent.x].amount=0;
		    	sw.world[newAgent.y][newAgent.x].amount+=cfg.substrate_for_dead_agent;	     	   
		    	continue;
		    }
            	            
            	    if ((!newAgent.died)&&(!newAgent.dead))
		    	this.world[newAgent.y][newAgent.x].amount=newAgent.agentID;	            
	            System.out.println("MEIOSIS: new agent added -> " +newAgent.agentID+" (parents: "+tmp.agentID+" and "+nb+")");
	            // energy_level for the involved agents 
	            // already updated in mitosis-function
	            
	        }
		else
		   // no partner found or not enough energy for meiosis 
		     // -> mitosis (if enough energy available)
		
		if (tmp.energy_level>=cfg.min_energy_mitose)
	        {
	            currentAgentID++;
	            Agent newAgent=null;
	            int free=findFreeAgent();
	            if (free==-1)
	            {
	            	newAgent=new Agent(tmp,cfg,rand,currentAgentID);
	            	newAgentCount++;
	            	newAgentCreated=true;
	            }
	            else
	            {
	            	//TODO: new -> overwrites old (uses not more memory)????
	            	newAgent=new Agent(tmp,cfg,rand,currentAgentID);
	            	newAgentCreated=false;
	            	agents.setElementAt((Object)newAgent,free);
	            }
	        
	            newAgent.x=tmp.x;
	            newAgent.y=tmp.y;
	            if (newAgentCreated)
	            	agents.add(newAgent); 
	            	
	            stepMitosisCount++;
	            tmp.gMitosisCount++;
	            
	            tmp.addChild(currentAgentID);
	            newAgent.setParents(tmp.agentID,-1);
	            	            
	            newAgent.madeMeiosis=false;
	    	    newAgent.madeMitosis=false;
	    	    newAgent.usedSubstrate=false;
	    	    newAgent.usedLight=false;
	    	    newAgent.dead=false;
	    	    newAgent.died=false;
	    	    newAgent.born=true;
		    newAgent.birthStep=steps;
	    			    			            
	            tmp.madeMitosis=true;
	            
	            System.out.println("MITOSIS: new agent added -> " +/*currentAgentID*/newAgent.agentID+" (parent = "+tmp.agentID+")");
	                 
	            int freeDir=findNeighbour(tmp,true);
		
	            if (freeDir!=-1)
	            {
	            	switch (freeDir) {
	                   	case 1: newAgent.x=tmp.x-1;
	                   	   	newAgent.y=tmp.y;
	                   	   	break;
	                   	case 2: newAgent.x=tmp.x+1;
	                   	   	newAgent.y=tmp.y;
	                   	   	break;
	                   	case 3: newAgent.x=tmp.x;
	                   	   	newAgent.y=tmp.y-1;
	                   	   	break;
	                   	case 4: newAgent.x=tmp.x;
	                   	   	newAgent.y=tmp.y+1;
	                   	   	break;
	                   	case 5: newAgent.x=tmp.x-1;
	                   	   	newAgent.y=tmp.y-1;
	                   	   	break;
	                   	case 6: newAgent.x=tmp.x+1;
	                   	   	newAgent.y=tmp.y-1;
	                   	   	break;
	                   	case 7: newAgent.x=tmp.x-1;
	                   	   	newAgent.y=tmp.y+1;
	                   	   	break;
	                   	case 8: newAgent.x=tmp.x+1;
	                   	   	newAgent.y=tmp.y+1;
	                   	   	break;
	                   	}
	                        if (this.world[newAgent.y][newAgent.x].amount==0.0)
	                        {
	                            this.world[newAgent.y][newAgent.x].amount=newAgent.agentID;
	                            //lw.update(newAgent.x,newAgent.y);
	                        }
	                   	else
	                       	    System.out.println("Positioning error [MITOSIS 1] - should really never happen");
		    }
	            else
	            {
	                 // hmm, there is no free place around
	                 // let the new agent die
	                 // --> die
	                 newAgent.died=true;
	                 sw.world[newAgent.y][newAgent.x].amount+=cfg.substrate_for_dead_agent;	     	   
	                 stepDeadCount++;
	                 System.out.println("MITOSIS: new agent died because of no placement choice\n");		
	            }
	            
	            if (tmp.energy_level<=0.0f)
		    {
		    	System.out.println("agentID "+tmp.agentID+" died - movement");
	     	    	stepDeadCount++;
	     	    	tmp.died=true;
		    	sw.world[tmp.y][tmp.x].amount+=cfg.substrate_for_dead_agent;
		    	this.world[tmp.y][tmp.x].amount=0;
		
	            	continue;
	            }
	            
	            // test if agent is crippled
		    if ((newAgent.genoType.isCrippled())&&(newAgent.isAlive()))
		    {
		    	System.out.println("agentID "+newAgent.agentID+" died - crippled");
	     	    	newAgent.died=true;	    	
		    	stepDeadCount++;
		    	this.world[newAgent.y][newAgent.x].amount=0;
		    	sw.world[newAgent.y][newAgent.x].amount+=cfg.substrate_for_dead_agent;	     	   
		
		    }
            	    
	            if ((!newAgent.died)&&(!newAgent.dead))
		    	this.world[newAgent.y][newAgent.x].amount=newAgent.agentID;	            		   
	        }
	    }
	}

        lw.update();
	agentCount=newAgentCount; 
    }
    
    public int aliveAgents()
    {
    	Agent tmp;
    	
    	int retC=0;
    	for (int z=0; z<agentCount; z++)
    	{
    	     tmp=(Agent)agents.elementAt(z);
    	     
    	     if (tmp.isAlive())
    	     	 retC++;
     	}
     	
     	return retC;
    }
    
    public ViewAgent[] getList()
    {
    	Agent tmp;
    	
    	int retC=0;
    	for (int z=0; z<agentCount; z++)
    	{
    	     tmp=(Agent)agents.elementAt(z);
    	     
    	     if (tmp.isAlive())
    	     	 retC++;
     	}
	     	
     	if (retC==0)
     	   return null;
     	
     	ViewAgent retVal[] = new ViewAgent[retC];
    	
    	int i=0;
    	
    	for (int z=0; z<agentCount; z++)
    	{
    	     tmp=(Agent)agents.elementAt(z);
    	     
    	     if (tmp.isAlive())
    	     {
    	     	 retVal[i]=new ViewAgent(tmp.x,tmp.y,z,tmp.agentID,tmp.dir,tmp.energy_level);
    	     	 i++;  
             };
     	}
     	
     	return retVal;
    }
    
    public int livingAgents()
    {
    	int tmp=0;
    	Agent a;
    	
    	for (int z=0; z<agentCount; z++)
    	{
    	    a=(Agent)agents.elementAt(z);
    	    if (a.isAlive())
    	       tmp++;  
    	}
    	return tmp;
    }
        
    public int deadAgents()
    {
    	int tmp=0;
    	Agent a;
    	
    	for (int z=0; z<agentCount; z++)
    	{
    	    a=(Agent)agents.elementAt(z);
    	    if (!a.isAlive())
    	       tmp++;  
    	}
    	return tmp;
    }
    
    void printWorld()
    {
    	System.out.println("AGENTWORLD: world dump");
    	for (int zy=0; zy<cfg.height; zy++)
    	{
    	    for (int zx=0; zx<cfg.width; zx++)
	    {
	    	System.out.print((int)this.world[zy][zx].amount+" ");
	    }
	    System.out.println("");
	}
    }
    
} // AgentWorld
