package algae.simulation.worlds;

import java.util.*;
import algae.simulation.Settings;
import algae.simulation.view.ViewSubstrate;
/** A class that represents ...
 * 
 * @see OtherClasses
 * @author your_name_here
 */
public class SubstrateWorld extends World 
{
    // Attributes
    final static double AMOUNT = 1000;

    public double totalAmount;
    public double periodicAmount;

    public final double RENEWRATE;
    
    class Element extends World.Element
    {
	final double NOTHING = 0.0; 
	
	int stepsToRegenerate;
	int stepsToGo;
	
	// Constructors
	public Element()
	    {
		this.amount = NOTHING;
		this.stepsToRegenerate = 0;
	    }
	
	public Element(double amount, int dec)
	    {
		this.amount = amount;
		this.stepsToRegenerate = dec;
		this.stepsToGo = dec;
	    }
	
	// Operations
	
	public boolean exists()
	    {
		return (this != null && this.amount > 0);
	    }
	
	public boolean add(int steps)
	{
		return true;
	}

        public boolean put(float amount) 
	{
		return true;
	}
	
	public boolean remove(int steps) 
	    {
		if(!this.exists())
		    {	
			return false; 
		    }
		else 
		    {
//===========changed====================
	    		if (this.amount>=1.0)
	    		{
			   this.amount -= 1.0;
	         	   //totalAmount--;
			   used++;
			   
			   //this.stepsToRegenerate = (int) (1/RENEWRATE);
			}
			return true;
		    }
	    } //deplete
	
	boolean update()
	    {
//changed
		if((this.stepsToRegenerate==0)&&(this.amount<cfg.max_substrate_saturation))
		{
		    if (cfg.periodic_substrate==1)
		    {
		    	this.amount+=periodicAmount;
		    	this.stepsToRegenerate=this.stepsToGo;
		    	renew++;
		    }
		    else
		    if (totalAmount>=1.0)
		    {
		    	this.amount++;
		    	this.stepsToRegenerate=this.stepsToGo;
		    	renew++;
		    	totalAmount--;
		    }
		}
		else 
		if (stepsToRegenerate!=-1)
		{
		    this.stepsToRegenerate--;
		}
		
		if (this.amount>cfg.max_substrate_saturation)
		   this.amount=cfg.max_substrate_saturation;
		
		return true;		
	    } // update
	
    }// end class Element


    public SubstrateWorld(Settings set) 
    {
	super(set.height, set.width);
	cfg=set;
	this.totalAmount = set.substrate_amount;
	this.RENEWRATE = set.substrate_renew_rate;
	
	if (set.periodic_substrate==1)
	{
	   periodicAmount=(float)set.substrate_periodic_amount/((float)set.width*(float)set.height);
	   totalAmount=0;
	}
	
	for(int i = 0; i < set.height;i++) 
	    {	    
		for(int j = 0; j < set.width;j++) 
		    {
		    	if (set.periodic_substrate==1)
		    	{
		    	    this.world[i][j] = new Element(periodicAmount,set.substrate_periodic_steps);
			}
			else
			{		    	
			   if (1/(1+(set.height-i)) == 1)
			   {
			   	this.world[i][j] = new Element(1.0,(int)(set.height-i)*(int)(1/RENEWRATE));
			    	this.totalAmount--;
			   }
			   else
			   {
         		    	this.world[i][j] = new Element(0.0,(int)(set.height-i)*(int)(1/RENEWRATE));
			   }
			}			    
		    }
	    }
    }//Substrate World


    public void step(int step)
    {
	for(int i = 0; i < cfg.height;i++) 
	    {	    
		for(int j = 0; j < cfg.width;j++) 
		    {
			 this.world[i][j].update();
		    }
	    }
    }

    public ViewSubstrate[] getList()
    {
	ViewSubstrate ret[];
	
	int retC=0;
	for(int i = 0; i < cfg.height; i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
		    	if (this.world[i][j].amount>0.0)
	                   retC++;
		    }
	    }
	   
	if (retC==0)
	   return null;
	    	    
	ret=new ViewSubstrate[retC];
	int z=0;
	
	//this.amount=0;
	for(int i = 0; i < cfg.height;i++) 
	    {
		for(int j = 0; j < cfg.width;j++) 
		    {
			if(this.world[i][j].amount>0.0)
			{
			    ret[z]=new ViewSubstrate(j,i,this.world[i][j].value(j,i));		    
			    z++;
			}
		    }
	    }
	    
	return ret;
    }//getList
    
    public double getSubstrateAmount() {
	return this.totalAmount;
    }

} /* end class SubstrateWorld */
