
/**
 * NodePanel.java
 *
 *
 * Created: Wed Apr  4 18:47:12 2001
 *
 * @author Clemens Bauer
 * @version
 */
package netView;

import netView.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

class NodePanel extends JPanel {

    int selectedNode = -1;
    
    
    NetViewSource net;
    
    JLabel nodeID =new JLabel();

    JLabel input = new JLabel("Input: ");
    JLabel inputValue = new JLabel();    
    JLabel output = new JLabel("Output: ");
    JLabel outputValue = new JLabel();    
    
    ConnectionTable connections;    
    JScrollPane sTable;
    
    Graph transferFunction;
    JScrollPane scrollingGraph;

    public NodePanel (NetViewSource src) {
	
	super();

	net =src;

	GridBagLayout g = (new GridBagLayout());
	GridBagConstraints c = new GridBagConstraints();
	this.setLayout(g);
	setBorder(BorderFactory.createTitledBorder("Neuron"));
	
	
	c.fill = GridBagConstraints.BOTH;
	c.weightx = 0.5;

	c.gridx = 0;
	c.gridy = 0;
	c.gridwidth = 2;
	g.setConstraints(nodeID, c);
	add(nodeID);

	c.gridwidth = 1;
	c.gridx = 0;
	c.gridy = 1;
	g.setConstraints(input, c);
	add(input);

	c.gridx = 1;
	g.setConstraints(inputValue, c);
	add(inputValue);

	c.gridx = 3;
	g.setConstraints(output, c);
	add(output);

	c.gridx = 4;
	g.setConstraints(outputValue, c);
	add(outputValue);


	connections = new ConnectionTable();
	
	connections.setPreferredSize(new Dimension(220, 200));
	sTable = new JScrollPane(connections);
	c.weighty = 0.5;
	c.gridwidth = 5;
	c.anchor = GridBagConstraints.NORTHWEST; //bottom of space
	c.gridx = 0;
	c.gridy = 2; 
	g.setConstraints(sTable, c);
	add(sTable);
	
// 	transferFunction = new Graph();
// 	// init layout transferFunction

// 	scrollingGraph = new JScrollPane(transferFunction);
	
// 	scrollingGraph.setPreferredSize(new Dimension(180,400));
// 	c.gridy = 3;
// 	c.anchor = GridBagConstraints.SOUTHEAST;
// 	g.setConstraints(scrollingGraph, c);
	
// 	this.add(scrollingGraph);
    }
    

    public void setSelected(int index) {
	byte[][] c;
	float[][] w;
	float[] v;
	
	connections.clearTables();
	nodeID.setText("");
	
	if((net == null) || (index < 0))
	    return; // get out 

	selectedNode = index;
	nodeID.setText("Neuron No. "+selectedNode);
	
       	c = net.getTopology();
	w = net.getWeights();
	v = new float[0];

	if(net.running())
	    v = net.getNetActivations();
	
	float sumIn = .0f; 
	float out = .0f;

	for(int i = 0; i < w.length; i++){
	    
	    if(index != i)
		{
		    //in
		    if(c[i][index] == 1)
			{
			    if(net.running()){
				connections.addInput(i,
						     w[i][index],
						     v[i]);
				sumIn += v[i];
			    }

			    else
				connections.addInput(i,
						     w[i][index]);
			}
	    
		    //out
		    if(c[index][i] == 1)
			connections.addOutput(i,
					      w[index][i]);
		}//if(index ..
	}//for
	
	if(net.running()){

	    //pfui
	    out =  v[index];

	    inputValue.setText(Float.toString(sumIn));
	    outputValue.setText(Float.toString(out));
	}
	
	else{
	    inputValue.setText("-");
	    outputValue.setText("-");
	}

	// refresh Transferfunction
    }
    
    public int  getSelected() {
	return selectedNode;
    }
    
    
}// NodePanel
